diff --git a/changelog b/changelog
index 8acaf43..f6db6a4 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,11 @@
+20080104 mxr src/input/repa6.input fix function names (7093)
+20080104 mxr src/input/knot2.input fix function names (7093)
+20080104 mxr src/input/grpthry.input fix function names (7093)
+20080104 mxr src/input/exsum.input fix function names (7093)
+20080104 mxr src/input/exlap.input fix function names (7093)
+20080104 mxr src/input/easter.input fix function names (7093)
+20080104 mxr src/input/collect.input fix function names (7093)
+20080104 mxr src/input/calculus2.input fix function names (7093)
 20080103 wxh src/algebra/sf.spad handle besselK (7090/355)
 20080103 wxh src/algebra/op.spad handle besselK (7090/355)
 20080103 wxh src/algebra/combfunc.spad handle besselK (7090/355)	
diff --git a/src/input/calculus2.input.pamphlet b/src/input/calculus2.input.pamphlet
index 3db6893..031f0ec 100644
--- a/src/input/calculus2.input.pamphlet
+++ b/src/input/calculus2.input.pamphlet
@@ -370,7 +370,7 @@ eq := differentiate(y(x), x, 3) - sin(differentiate(y(x), x, 2)) * exp(y(x)) = c
 --S 29 of 112
 seriesSolve(eq, y, x = 0, [1, 0, 0])
 --R 
---R   Compiling function %B with type List UnivariateTaylorSeries(
+--I   Compiling function %B with type List UnivariateTaylorSeries(
 --R      Expression Integer,x,0) -> UnivariateTaylorSeries(Expression 
 --R      Integer,x,0) 
 --R
@@ -388,7 +388,7 @@ seriesSolve(eq, y, x = 0, [1, 0, 0])
 --S 30 of 112
 x := operator 'x
 --R 
---R   Compiled code for %B has been cleared.
+--I   Compiled code for %B has been cleared.
 --R
 --R   (4)  x
 --R                                                          Type: BasicOperator
@@ -417,10 +417,10 @@ eq2 := differentiate(y(t), t) = x(t) * y(t)
 --S 33 of 112
 seriesSolve([eq2, eq1], [x, y], t = 0, [y(0) = 1, x(0) = 0])
 --R 
---R   Compiling function %D with type List UnivariateTaylorSeries(
+--I   Compiling function %D with type List UnivariateTaylorSeries(
 --R      Expression Integer,t,0) -> UnivariateTaylorSeries(Expression 
 --R      Integer,t,0) 
---R   Compiling function %E with type List UnivariateTaylorSeries(
+--I   Compiling function %E with type List UnivariateTaylorSeries(
 --R      Expression Integer,t,0) -> UnivariateTaylorSeries(Expression 
 --R      Integer,t,0) 
 --R
@@ -493,37 +493,27 @@ laplace((cos(a*t) - cos(b*t))/t, t, s)
 --E 39
 
 --S 40 of 112
-laplace(exp(a*t+b)*ei(c*t), t, s)
---R 
---R   There are no library operations named ei 
---R      Use HyperDoc Browse or issue
---R                                 )what op ei
---R      to learn if there is any operation containing " ei " in its name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named ei 
---R      with argument type(s) 
---R                             Polynomial Integer
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+laplace(exp(a*t+b)*Ei(c*t), t, s)
+--R
+--R          b    s + c - a
+--R        %e log(---------)
+--R                   c
+--R   (7)  -----------------
+--R              s - a
+--R                                                     Type: Expression Integer
 --E 40
 
 --S 41 of 112
-laplace(a*ci(b*t) + c*si(d*t), t, s)
---R 
---R   There are no library operations named ci 
---R      Use HyperDoc Browse or issue
---R                                 )what op ci
---R      to learn if there is any operation containing " ci " in its name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named ci 
---R      with argument type(s) 
---R                             Polynomial Integer
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+laplace(a*Ci(b*t) + c*Si(d*t), t, s)
+--R
+--R               2    2
+--R              s  + b             d
+--R        a log(-------) + 2c atan(-)
+--R                  2              s
+--R                 b
+--R   (8)  ---------------------------
+--R                     2s
+--R                                                     Type: Expression Integer
 --E 41
 
 --S 42 of 112
@@ -533,7 +523,7 @@ laplace(sin(a*t) - a*t*cos(a*t) + exp(t**2), t, s)
 --R                                    2
 --R          4     2 2    4           t           3
 --R        (s  + 2a s  + a )laplace(%e  ,t,s) + 2a
---R   (7)  ----------------------------------------
+--R   (9)  ----------------------------------------
 --R                      4     2 2    4
 --R                     s  + 2a s  + a
 --R                                                     Type: Expression Integer
@@ -637,9 +627,9 @@ integrate(g, x)
 --R 
 --R
 --R           x      +--------+
---R         ++  log(\|b + %G a  + 1)
---R   (4)   |   -------------------- d%G
---R        ++            %G
+--I         ++  log(\|b + %G a  + 1)
+--I   (4)   |   -------------------- d%G
+--I        ++            %G
 --R                                          Type: Union(Expression Integer,...)
 --E 51
 
diff --git a/src/input/collect.input.pamphlet b/src/input/collect.input.pamphlet
index 5e92eda..9e07896 100644
--- a/src/input/collect.input.pamphlet
+++ b/src/input/collect.input.pamphlet
@@ -91,10 +91,71 @@ e := reverse [i**3 for i in 10..0 by -2 | even? i]
 --R                                                           Type: List Integer
 --E 9
 
+--S 10 of 55
+[x**3 - y for x in b | even? x for y in e]
+--R
+--R   (10)  [0,- 56,- 448]
+--R                                                           Type: List Integer
+--E 10
+
+--S 11 of 55
+f := [i**3 for i in 0..]
+--R
+--R   (11)  [0,1,8,27,64,125,216,343,512,729,...]
+--R                                              Type: Stream NonNegativeInteger
+--E 11
+
+--S 12 of 55
+[i**3 for i in 0..10]
+--R
+--R   (12)  [0,1,8,27,64,125,216,343,512,729,1000]
+--R                                                Type: List NonNegativeInteger
+--E 12
+
+--S 13 of 55
+[i**3 for i in 0.. while i < 11]
+--R
+--R   (13)  [0,1,8,27,64,125,216,343,512,729,...]
+--R                                              Type: Stream NonNegativeInteger
+--E 13
+
+--S 14 of 55
+[i**3 for i in 0.. for x in 0..10]
+--R
+--R   (14)  [0,1,8,27,64,125,216,343,512,729,...]
+--R                                              Type: Stream NonNegativeInteger
+--E 14
+
+--S 15 of 55
+[ [i**j for j in 0..3] for i in 0..]
+--R
+--R   (15)
+--R   [[1,0,0,0], [1,1,1,1], [1,2,4,8], [1,3,9,27], [1,4,16,64], [1,5,25,125],
+--R    [1,6,36,216], [1,7,49,343], [1,8,64,512], [1,9,81,729], ...]
+--R                                         Type: Stream List NonNegativeInteger
+--E 15
+
+--S 16 of 55
+[ [i**j for j in 0..] for i in 0..3]
+--R
+--R   (16)
+--R   [[1,0,0,0,0,0,0,0,0,0,...], [1,1,1,1,1,1,1,1,1,1,...],
+--R    [1,2,4,8,16,32,64,128,256,512,...],
+--R    [1,3,9,27,81,243,729,2187,6561,19683,...]]
+--R                                           Type: List Stream Fraction Integer
+--E 16
+
+--S 17 of 55
+brace [i**3 for i in 10..0 by -2]
+--R
+--R   (17)  {0,8,64,216,512,1000}
+--R                                                 Type: Set NonNegativeInteger
+--E 17
+
 -- Input generated from ContinuedFractionXmpPage
 )clear all
 
---S 10 of 55
+--S 18 of 55
 c := continuedFraction(314159/100000)
 --R 
 --R
@@ -102,17 +163,17 @@ c := continuedFraction(314159/100000)
 --R   (1)  3 + +---+ + +----+ + +---+ + +----+ + +---+ + +---+ + +---+
 --R            | 7     | 15     | 1     | 25     | 1     | 7     | 4
 --R                                              Type: ContinuedFraction Integer
---E 10
+--E 18
 
---S 11 of 55
+--S 19 of 55
 partialQuotients c
 --R 
 --R
 --R   (2)  [3,7,15,1,25,1,7,4]
 --R                                                         Type: Stream Integer
---E 11
+--E 19
 
---S 12 of 55
+--S 20 of 55
 convergents c
 --R 
 --R
@@ -120,9 +181,9 @@ convergents c
 --R   (3)  [3,--,---,---,----,----,-----,------]
 --R            7 106 113 2931 3044 24239 100000
 --R                                                Type: Stream Fraction Integer
---E 12
+--E 20
 
---S 13 of 55
+--S 21 of 55
 approximants c
 --R 
 --R
@@ -131,17 +192,17 @@ approximants c
 --R   (4)  [3,--,---,---,----,----,-----,------]
 --R            7 106 113 2931 3044 24239 100000
 --R                                                Type: Stream Fraction Integer
---E 13
+--E 21
 
---S 14 of 55
+--S 22 of 55
 pq := partialQuotients(1/c)
 --R 
 --R
 --R   (5)  [0,3,7,15,1,25,1,7,4]
 --R                                                         Type: Stream Integer
---E 14
+--E 22
 
---S 15 of 55
+--S 23 of 55
 continuedFraction(first pq,repeating [1],rest pq)
 --R 
 --R
@@ -149,9 +210,9 @@ continuedFraction(first pq,repeating [1],rest pq)
 --R   (6)  +---+ + +---+ + +----+ + +---+ + +----+ + +---+ + +---+ + +---+
 --R        | 3     | 7     | 15     | 1     | 25     | 1     | 7     | 4
 --R                                              Type: ContinuedFraction Integer
---E 15
+--E 23
 
---S 16 of 55
+--S 24 of 55
 z:=continuedFraction(3,repeating [1],repeating [3,6])
 --R 
 --R
@@ -164,17 +225,17 @@ z:=continuedFraction(3,repeating [1],repeating [3,6])
 --R     +---+ + ...
 --R     | 6
 --R                                              Type: ContinuedFraction Integer
---E 16
+--E 24
 
---S 17 of 55
+--S 25 of 55
 dens:Stream Integer := cons(1,generate((x+->x+4),6))
 --R 
 --R
 --R   (8)  [1,6,10,14,18,22,26,30,34,38,...]
 --R                                                         Type: Stream Integer
---E 17
+--E 25
 
---S 18 of 55
+--S 26 of 55
 cf := continuedFraction(0,repeating [1],dens)
 --R 
 --R
@@ -187,9 +248,9 @@ cf := continuedFraction(0,repeating [1],dens)
 --R     +----+ + +----+ + ...
 --R     | 34     | 38
 --R                                              Type: ContinuedFraction Integer
---E 18
+--E 26
 
---S 19 of 55
+--S 27 of 55
 ccf := convergents cf
 --R 
 --R
@@ -197,9 +258,9 @@ ccf := convergents cf
 --R   (10)  [0,1,-,--,----,-----,------,--------,---------,-----------,...]
 --R              7 71 1001 18089 398959 10391023 312129649 10622799089
 --R                                                Type: Stream Fraction Integer
---E 19
+--E 27
 
---S 20 of 55
+--S 28 of 55
 eConvergents := [2*e + 1 for e in ccf]
 --R 
 --R
@@ -207,9 +268,9 @@ eConvergents := [2*e + 1 for e in ccf]
 --R   (11)  [1,3,--,---,----,-----,-------,--------,---------,-----------,...]
 --R               7  71 1001 18089  398959 10391023 312129649 10622799089
 --R                                                Type: Stream Fraction Integer
---E 20
+--E 28
 
---S 21 of 55
+--S 29 of 55
 eConvergents :: Stream Float
 --R 
 --R
@@ -219,17 +280,17 @@ eConvergents :: Stream Float
 --R    2.7182818284 590458514, 2.7182818284 590452348, 2.7182818284 590452354,
 --R    ...]
 --R                                                           Type: Stream Float
---E 21
+--E 29
 
---S 22 of 55
+--S 30 of 55
 exp 1.0
 --R 
 --R
 --R   (13)  2.7182818284 590452354
 --R                                                                  Type: Float
---E 22
+--E 30
 
---S 23 of 55
+--S 31 of 55
 cf := continuedFraction(1,[(2*i+1)**2 for i in 0..],repeating [2])
 --R 
 --R
@@ -242,9 +303,9 @@ cf := continuedFraction(1,[(2*i+1)**2 for i in 0..],repeating [2])
 --R     +-----+ + +-----+ + ...
 --R     |  2      |  2
 --R                                              Type: ContinuedFraction Integer
---E 23
+--E 31
 
---S 24 of 55
+--S 32 of 55
 ccf := convergents cf
 --R 
 --R
@@ -252,9 +313,9 @@ ccf := convergents cf
 --R   (15)  [1,-,--,---,---,----,-----,-----,------,--------,...]
 --R            2 13  76 263 2578 36979 33976 622637 11064338
 --R                                                Type: Stream Fraction Integer
---E 24
+--E 32
 
---S 25 of 55
+--S 33 of 55
 piConvergents := [4/p for p in ccf]
 --R 
 --R
@@ -262,9 +323,9 @@ piConvergents := [4/p for p in ccf]
 --R   (16)  [4,-,--,---,----,-----,------,------,-------,--------,...]
 --R            3 15 105  315  3465  45045  45045  765765 14549535
 --R                                                Type: Stream Fraction Integer
---E 25
+--E 33
 
---S 26 of 55
+--S 34 of 55
 piConvergents :: Stream Float
 --R 
 --R
@@ -274,9 +335,9 @@ piConvergents :: Stream Float
 --R    3.2837384837 384837385, 3.0170718170 718170718, 3.2523659347 188758953,
 --R    3.0418396189 294022111, ...]
 --R                                                           Type: Stream Float
---E 26
+--E 34
 
---S 27 of 55
+--S 35 of 55
 continuedFraction((- 122 + 597*%i)/(4 - 4*%i))
 --R 
 --R
@@ -284,15 +345,15 @@ continuedFraction((- 122 + 597*%i)/(4 - 4*%i))
 --R   (18)  - 90 + 59%i + +---------+ + +-----------+
 --R                       | 1 - 2%i     | - 1 + 2%i
 --R                                      Type: ContinuedFraction Complex Integer
---E 27
+--E 35
 
---S 28 of 55
+--S 36 of 55
 r : Fraction UnivariatePolynomial(x,Fraction Integer)
 --R 
 --R                                                                   Type: Void
---E 28
+--E 36
 
---S 29 of 55
+--S 37 of 55
 r := ((x - 1) * (x - 2)) / ((x-3) * (x-4))
 --R 
 --R
@@ -302,9 +363,9 @@ r := ((x - 1) * (x - 2)) / ((x-3) * (x-4))
 --R          2
 --R         x  - 7x + 12
 --R                      Type: Fraction UnivariatePolynomial(x,Fraction Integer)
---E 29
+--E 37
 
---S 30 of 55
+--S 38 of 55
 continuedFraction r
 --R 
 --R
@@ -314,9 +375,9 @@ continuedFraction r
 --R             | - x - -     | -- x - --
 --R             | 4     8     |  3      3
 --R             Type: ContinuedFraction UnivariatePolynomial(x,Fraction Integer)
---E 30
+--E 38
 
---S 31 of 55
+--S 39 of 55
 [i*i for i in convergents(z) :: Stream Float]
 --R 
 --R
@@ -326,77 +387,6 @@ continuedFraction r
 --R    11.0000000017 53603304, 10.9999999999 12099531, 11.0000000000 04406066,
 --R    ...]
 --R                                                           Type: Stream Float
---E 31
-
---S 32 of 55
-[x**3 - y for x in b | even? x for y in e]
---R 
---R 
---RDaly Bug
---R   AXIOM cannot iterate with x over your form now. Perhaps you should 
---R      try using a conversion to make sure your form is a list or 
---R      stream, for example.
---E 32
-
---S 33 of 55
-f := [i**3 for i in 0..]
---R 
---R
---R   (23)  [0,1,8,27,64,125,216,343,512,729,...]
---R                                              Type: Stream NonNegativeInteger
---E 33
-
---S 34 of 55
-[i**3 for i in 0..10]
---R 
---R
---R   (24)  [0,1,8,27,64,125,216,343,512,729,1000]
---R                                                Type: List NonNegativeInteger
---E 34
-
---S 35 of 55
-[i**3 for i in 0.. while i < 11]
---R 
---R
---R   (25)  [0,1,8,27,64,125,216,343,512,729,...]
---R                                              Type: Stream NonNegativeInteger
---E 35
-
---S 36 of 55
-[i**3 for i in 0.. for x in 0..10]
---R 
---R
---R   (26)  [0,1,8,27,64,125,216,343,512,729,...]
---R                                              Type: Stream NonNegativeInteger
---E 36
-
---S 37 of 55
-[[i**j for j in 0..3] for i in 0..]
---R 
---R
---R   (27)
---R   [[1,0,0,0], [1,1,1,1], [1,2,4,8], [1,3,9,27], [1,4,16,64], [1,5,25,125],
---R    [1,6,36,216], [1,7,49,343], [1,8,64,512], [1,9,81,729], ...]
---R                                         Type: Stream List NonNegativeInteger
---E 37
-
---S 38 of 55
-[[i**j for j in 0..] for i in 0..3]
---R 
---R
---R   (28)
---R   [[1,0,0,0,0,0,0,0,0,0,...], [1,1,1,1,1,1,1,1,1,1,...],
---R    [1,2,4,8,16,32,64,128,256,512,...],
---R    [1,3,9,27,81,243,729,2187,6561,19683,...]]
---R                                           Type: List Stream Fraction Integer
---E 38
-
---S 39 of 55
-brace [i**3 for i in 10..0 by -2]
---R 
---R
---R   (29)  {0,8,64,216,512,1000}
---R                                                 Type: Set NonNegativeInteger
 --E 39
 
 -- Input for page ForCollectionDetailPage
diff --git a/src/input/easter.input.pamphlet b/src/input/easter.input.pamphlet
index 5db2309..64c9c44 100644
--- a/src/input/easter.input.pamphlet
+++ b/src/input/easter.input.pamphlet
@@ -28,7 +28,7 @@
 \section{Numbers}
 Let's begin by playing with numbers: infinite precision integers
 <<*>>=
---S 1 of 201
+--S 1 of 200
 factorial(50)
 --R 
 --R
@@ -36,7 +36,7 @@ factorial(50)
 --R                                                        Type: PositiveInteger
 --E 1
 
---S 2 of 201
+--S 2 of 200
 factor(%)
 --R 
 --R
@@ -48,7 +48,7 @@ factor(%)
 @
 Infinite precision rational numbers
 <<*>>=
---S 3 of 201
+--S 3 of 200
 1/2 + 1/3 + 1/4 + 1/5 + 1/6 + 1/7 + 1/8 + 1/9 + 1/10
 --R 
 --R
@@ -61,7 +61,7 @@ Infinite precision rational numbers
 @
 Arbitrary precision floating point numbers
 <<*>>=
---S 4 of 201
+--S 4 of 200
 digits(50);
 --R 
 --R
@@ -71,7 +71,7 @@ digits(50);
 @
 This number is nearly an integer
 <<*>>=
---S 5 of 201
+--S 5 of 200
 exp(sqrt(163.)*%pi)
 --R 
 --R
@@ -79,7 +79,7 @@ exp(sqrt(163.)*%pi)
 --R                                                                  Type: Float
 --E 5
 
---S 6 of 201
+--S 6 of 200
 digits(20);
 --R 
 --R
@@ -89,7 +89,7 @@ digits(20);
 @
 Special functions
 <<*>>=
---S 7 of 201
+--S 7 of 200
 besselJ(2, 1 + %i)
 --R 
 --R
@@ -100,7 +100,7 @@ besselJ(2, 1 + %i)
 @
 Complete decimal expansion of a rational number
 <<*>>=
---S 8 of 201
+--S 8 of 200
 decimal(1/7)
 --R 
 --R
@@ -112,7 +112,7 @@ decimal(1/7)
 @
 Continued fractions
 <<*>>=
---S 9 of 201
+--S 9 of 200
 continuedFraction(3.1415926535)
 --R 
 --R
@@ -125,7 +125,7 @@ continuedFraction(3.1415926535)
 @
 Simplify an expression with nested square roots
 <<*>>=
---S 10 of 201
+--S 10 of 200
 sqrt(2*sqrt(3) + 4)
 --R 
 --R
@@ -135,7 +135,7 @@ sqrt(2*sqrt(3) + 4)
 --R                                                        Type: AlgebraicNumber
 --E 10
 
---S 11 of 201
+--S 11 of 200
 simplify(%)
 --R 
 --R
@@ -148,7 +148,7 @@ simplify(%)
 @
 Try a more complicated example (from the Putnam exam)
 <<*>>=
---S 12 of 201
+--S 12 of 200
 sqrt(14 + 3*sqrt(3 + 2*sqrt(5 - 12*sqrt(3 - 2*sqrt(2)))))
 --R 
 --R
@@ -161,7 +161,7 @@ sqrt(14 + 3*sqrt(3 + 2*sqrt(5 - 12*sqrt(3 - 2*sqrt(2)))))
 --R                                                        Type: AlgebraicNumber
 --E 12
 
---S 13 of 201
+--S 13 of 200
 simplify(%)
 --R 
 --R
@@ -177,7 +177,7 @@ simplify(%)
 @
 Cardinal numbers
 <<*>>=
---S 14 of 201
+--S 14 of 200
 2*Aleph(0) - 3
 --R 
 --R
@@ -190,7 +190,7 @@ Cardinal numbers
 Numbers are nice, but symbols allow for variability---try some high school
 algebra: rational simplification
 <<*>>=
---S 15 of 201
+--S 15 of 200
 (x**2 - 4)/(x**2 + 4*x + 4)
 --R 
 --R
@@ -203,7 +203,7 @@ algebra: rational simplification
 @
 This example requires more sophistication
 <<*>>=
---S 16 of 201
+--S 16 of 200
 (%e**x - 1)/(%e**(x/2) + 1)
 --R 
 --R
@@ -217,7 +217,7 @@ This example requires more sophistication
 --R                                                     Type: Expression Integer
 --E 16
 
---S 17 of 201
+--S 17 of 200
 normalize(%)
 --R 
 --R
@@ -231,7 +231,7 @@ normalize(%)
 @
 Expand and factor polynomials
 <<*>>=
---S 18 of 201
+--S 18 of 200
 (x + 1)**20
 --R 
 --R
@@ -247,7 +247,7 @@ Expand and factor polynomials
 --R                                                     Type: Polynomial Integer
 --E 18
 
---S 19 of 201
+--S 19 of 200
 D(%, x)
 --R 
 --R
@@ -263,7 +263,7 @@ D(%, x)
 --R                                                     Type: Polynomial Integer
 --E 19
 
---S 20 of 201
+--S 20 of 200
 factor(%)
 --R 
 --R
@@ -272,7 +272,7 @@ factor(%)
 --R                                            Type: Factored Polynomial Integer
 --E 20
 
---S 21 of 201
+--S 21 of 200
 x**100 - 1
 --R 
 --R
@@ -281,7 +281,7 @@ x**100 - 1
 --R                                                     Type: Polynomial Integer
 --E 21
 
---S 22 of 201
+--S 22 of 200
 factor(%)
 --R 
 --R
@@ -300,7 +300,7 @@ factor(%)
 @
 Factor polynomials over finite fields and field extensions
 <<*>>=
---S 23 of 201
+--S 23 of 200
 p:= x**4 - 3*x**2 + 1
 --R 
 --R
@@ -309,7 +309,7 @@ p:= x**4 - 3*x**2 + 1
 --R                                                     Type: Polynomial Integer
 --E 23
 
---S 24 of 201
+--S 24 of 200
 factor(p)
 --R 
 --R
@@ -318,14 +318,14 @@ factor(p)
 --R                                            Type: Factored Polynomial Integer
 --E 24
 
---S 25 of 201
+--S 25 of 200
 phi:= rootOf(phi**2 - phi - 1);
 --R 
 --R
 --R                                                        Type: AlgebraicNumber
 --E 25
 
---S 26 of 201
+--S 26 of 200
 factor(p, [phi])
 --R 
 --R
@@ -333,7 +333,7 @@ factor(p, [phi])
 --R                                    Type: Factored Polynomial AlgebraicNumber
 --E 26
 
---S 27 of 201
+--S 27 of 200
 factor(p :: Polynomial(PrimeField(5)))
 --R 
 --R
@@ -342,7 +342,7 @@ factor(p :: Polynomial(PrimeField(5)))
 --R                                       Type: Factored Polynomial PrimeField 5
 --E 27
 
---S 28 of 201
+--S 28 of 200
 expand(%)
 --R 
 --R
@@ -354,7 +354,7 @@ expand(%)
 @
 Partial fraction decomposition
 <<*>>=
---S 29 of 201
+--S 29 of 200
 (x**2 + 2*x + 3)/(x**3 + 4*x**2 + 5*x + 2)
 --R 
 --R
@@ -366,7 +366,7 @@ Partial fraction decomposition
 --R                                            Type: Fraction Polynomial Integer
 --E 29
 
---S 30 of 201
+--S 30 of 200
 padicFraction(
    partialFraction(numerator(%) :: UnivariatePolynomial(x, Fraction Integer),
                    factor(denominator(%) :: Polynomial Integer) ::
@@ -384,7 +384,7 @@ padicFraction(
 \section{Trigonometry}
 Trigonometric manipulations---these are typically difficult for students
 <<*>>=
---S 31 of 201
+--S 31 of 200
 r:= cos(3*x)/cos(x)
 --R 
 --R
@@ -394,7 +394,7 @@ r:= cos(3*x)/cos(x)
 --R                                                     Type: Expression Integer
 --E 31
 
---S 32 of 201
+--S 32 of 200
 real(complexNormalize(%))
 --R 
 --R
@@ -403,7 +403,7 @@ real(complexNormalize(%))
 --R                                                     Type: Expression Integer
 --E 32
 
---S 33 of 201
+--S 33 of 200
 real(normalize(simplify(complexNormalize(r))))
 --R 
 --R
@@ -414,7 +414,7 @@ real(normalize(simplify(complexNormalize(r))))
 @
 Use rewrite rules
 <<*>>=
---S 34 of 201
+--S 34 of 200
 sincosAngles:= rule _
   (cos((n | integer?(n)) * x) == _
       cos((n - 1)*x) * cos(x) - sin((n - 1)*x) * sin(x); _
@@ -428,7 +428,7 @@ sincosAngles:= rule _
 --R                            Type: Ruleset(Integer,Integer,Expression Integer)
 --E 34
 
---S 35 of 201
+--S 35 of 200
 sincosAngles r
 --R 
 --R
@@ -437,7 +437,7 @@ sincosAngles r
 --R                                                     Type: Expression Integer
 --E 35
 
---S 36 of 201
+--S 36 of 200
 r:= 'r;
 --R 
 --R
@@ -448,7 +448,7 @@ r:= 'r;
 \section{Determining Zero Equivalence}
 The following expressions are all equal to zero
 <<*>>=
---S 37 of 201
+--S 37 of 200
 sqrt(997) - (997**3)**(1/6)
 --R 
 --R
@@ -456,7 +456,7 @@ sqrt(997) - (997**3)**(1/6)
 --R                                                        Type: AlgebraicNumber
 --E 37
 
---S 38 of 201
+--S 38 of 200
 sqrt(999983) - (999983**3)**(1/6)
 --R 
 --R
@@ -464,7 +464,7 @@ sqrt(999983) - (999983**3)**(1/6)
 --R                                                        Type: AlgebraicNumber
 --E 38
 
---S 39 of 201
+--S 39 of 200
 (2**(1/3) + 4**(1/3))**3 - 6*(2**(1/3) + 4**(1/3)) - 6
 --R 
 --R
@@ -473,7 +473,7 @@ sqrt(999983) - (999983**3)**(1/6)
 --R                                                        Type: AlgebraicNumber
 --E 39
 
---S 40 of 201
+--S 40 of 200
 simplify(%)
 --R 
 --R
@@ -485,7 +485,7 @@ simplify(%)
 @
 This expression is zero for $x, y > 0$ and $n$ not equal to zero
 <<*>>=
---S 41 of 201
+--S 41 of 200
 x**(1/n)*y**(1/n) - (x*y)**(1/n)
 --R 
 --R
@@ -496,7 +496,7 @@ x**(1/n)*y**(1/n) - (x*y)**(1/n)
 --R                                                     Type: Expression Integer
 --E 41
 
---S 42 of 201
+--S 42 of 200
 normalize(%)
 --R 
 --R
@@ -508,7 +508,7 @@ normalize(%)
 See Joel Moses, ``Algebraic Simplification: A Guide for the Perplexed'',
 CACM, Volume 14, Number 8, August 1971
 <<*>>=
---S 43 of 201
+--S 43 of 200
 expr:= log(tan(1/2*x + %pi/4)) - asinh(tan(x))
 --R 
 --R
@@ -518,7 +518,7 @@ expr:= log(tan(1/2*x + %pi/4)) - asinh(tan(x))
 --R                                                     Type: Expression Integer
 --E 43
 
---S 44 of 201
+--S 44 of 200
 complexNormalize(%)
 --R 
 --R
@@ -573,7 +573,7 @@ complexNormalize(%)
 @
 Use a roundabout method---show that expr is a constant equal to zero
 <<*>>=
---S 45 of 201
+--S 45 of 200
 D(expr, x)
 --R 
 --R
@@ -590,7 +590,7 @@ D(expr, x)
 --R                                                     Type: Expression Integer
 --E 45
 
---S 46 of 201
+--S 46 of 200
 simplify(real(complexNormalize(expand(simplify(%)))))
 --R 
 --R
@@ -611,7 +611,7 @@ simplify(real(complexNormalize(expand(simplify(%)))))
 --R                                                     Type: Expression Integer
 --E 46
 
---S 47 of 201
+--S 47 of 200
 normalize(eval(expr, x = 0))
 --R 
 --R
@@ -619,7 +619,7 @@ normalize(eval(expr, x = 0))
 --R                                                     Type: Expression Integer
 --E 47
 
---S 48 of 201
+--S 48 of 200
 log((2*sqrt(r) + 1)/sqrt(4*r + 4*sqrt(r) + 1))
 --R 
 --R
@@ -632,7 +632,7 @@ log((2*sqrt(r) + 1)/sqrt(4*r + 4*sqrt(r) + 1))
 --R                                                     Type: Expression Integer
 --E 48
 
---S 49 of 201
+--S 49 of 200
 simplify(%)
 --R 
 --R
@@ -645,7 +645,7 @@ simplify(%)
 --R                                                     Type: Expression Integer
 --E 49
 
---S 50 of 201
+--S 50 of 200
 (4*r + 4*sqrt(r) + 1)**(sqrt(r)/(2*sqrt(r) + 1)) _
    * (2*sqrt(r) + 1)**(1/(2*sqrt(r) + 1)) - 2*sqrt(r) - 1
 --R 
@@ -659,7 +659,7 @@ simplify(%)
 --R                                                     Type: Expression Integer
 --E 50
 
---S 51 of 201
+--S 51 of 200
 normalize(%)
 --R 
 --R
@@ -671,13 +671,13 @@ normalize(%)
 \section{The Complex Domain}
  Complex functions---separate into their real and imaginary parts
 <<*>>=
---S 52 of 201
+--S 52 of 200
 rectform(z) == real(z) + %i*imag(z)
 --R 
 --R                                                                   Type: Void
 --E 52
 
---S 53 of 201
+--S 53 of 200
 rectform(log(3 + 4*%i))
 --R 
 --R   Compiling function rectform with type Expression Complex Integer -> 
@@ -691,7 +691,7 @@ rectform(log(3 + 4*%i))
 --R                                             Type: Expression Complex Integer
 --E 53
 
---S 54 of 201
+--S 54 of 200
 simplify(rectform(tan(x + %i*y)))
 --R 
 --R
@@ -710,7 +710,7 @@ September 1991.  This first expression can simplify to
 $\sqrt{(x y)}/\sqrt{(x)}$,
 but no further in general (consider what happens when x, y = -1).
 <<*>>=
---S 55 of 201
+--S 55 of 200
 sqrt(x*y*abs(z)**2) / (sqrt(x)*abs(z))
 --R 
 --R
@@ -726,7 +726,7 @@ sqrt(x*y*abs(z)**2) / (sqrt(x)*abs(z))
 @
 If $z = -1$, $\sqrt(1/z)$ is not equal to $1/\sqrt(z)$
 <<*>>=
---S 56 of 201
+--S 56 of 200
 sqrt(1/z) - 1/sqrt(z)
 --R 
 --R
@@ -743,7 +743,7 @@ sqrt(1/z) - 1/sqrt(z)
 @
 If $z = 3 \pi i$, $\log(\exp(z))$ is not equal to $z$
 <<*>>=
---S 57 of 201
+--S 57 of 200
 log(%e**z)
 --R 
 --R
@@ -751,7 +751,7 @@ log(%e**z)
 --R                                                     Type: Expression Integer
 --E 57
 
---S 58 of 201
+--S 58 of 200
 normalize(%)
 --R 
 --R
@@ -762,7 +762,7 @@ normalize(%)
 @
 The principal value of this expression is $(10 - 4 \pi) i$
 <<*>>=
---S 59 of 201
+--S 59 of 200
 log(%e**(10*%i))
 --R 
 --R
@@ -771,7 +771,7 @@ log(%e**(10*%i))
 --R                                             Type: Expression Complex Integer
 --E 59
 
---S 60 of 201
+--S 60 of 200
 normalize(%)
 --R 
 --R
@@ -783,7 +783,7 @@ normalize(%)
 @
 If $z = \pi$, $\arctan(\tan(z))$ is not equal to $z$
 <<*>>=
---S 61 of 201
+--S 61 of 200
 atan(tan(z))
 --R 
 --R
@@ -794,7 +794,7 @@ atan(tan(z))
 @
 If $z = 2 \pi i$, $\sqrt(\exp(z))$ is not equal to $\exp(z/2)$
 <<*>>=
---S 62 of 201
+--S 62 of 200
 sqrt(%e**z) - %e**(z/2)
 --R 
 --R
@@ -809,7 +809,7 @@ sqrt(%e**z) - %e**(z/2)
 \section{Equations}
 Manipulate an equation using a natural syntax
 <<*>>=
---S 63 of 201
+--S 63 of 200
 (x = 0)/2 + 1
 --R 
 --R
@@ -822,7 +822,7 @@ Manipulate an equation using a natural syntax
 @
 Solve various nonlinear equations---this cubic polynomial has all real roots
 <<*>>=
---S 64 of 201
+--S 64 of 200
 radicalSolve(3*x**3 - 18*x**2 + 33*x - 19 = 0, x)
 --R 
 --R
@@ -869,7 +869,7 @@ radicalSolve(3*x**3 - 18*x**2 + 33*x - 19 = 0, x)
 --R                                       Type: List Equation Expression Integer
 --E 64
 
---S 65 of 201
+--S 65 of 200
 map(e +-> lhs(e) = rectform(rhs(e)), %)
 --R 
 --R   Compiling function rectform with type Expression Integer -> 
@@ -924,7 +924,7 @@ map(e +-> lhs(e) = rectform(rhs(e)), %)
 @
 Some simple seeming problems can have messy answers
 <<*>>=
---S 66 of 201
+--S 66 of 200
 eqn:= x**4 + x**3 + x**2 + x + 1 = 0
 --R 
 --R
@@ -933,7 +933,7 @@ eqn:= x**4 + x**3 + x**2 + x + 1 = 0
 --R                                            Type: Equation Polynomial Integer
 --E 66
 
---S 67 of 201
+--S 67 of 200
 radicalSolve(eqn, x)
 --R 
 --R
@@ -1284,7 +1284,7 @@ radicalSolve(eqn, x)
 @
 Check one of the answers
 <<*>>=
---S 68 of 201
+--S 68 of 200
 eval(eqn, %.1)
 --R 
 --R
@@ -1373,7 +1373,7 @@ eval(eqn, %.1)
 --R                                            Type: Equation Expression Integer
 --E 68
 
---S 69 of 201
+--S 69 of 200
 %e**(2*x) + 2*%e**x + 1 = z
 --R 
 --R
@@ -1382,7 +1382,7 @@ eval(eqn, %.1)
 --R                                            Type: Equation Expression Integer
 --E 69
 
---S 70 of 201
+--S 70 of 200
 solve(%, x)
 --R 
 --R
@@ -1394,7 +1394,7 @@ solve(%, x)
 @
 This equation is already factored and so {\sl should} be easy to solve
 <<*>>=
---S 71 of 201
+--S 71 of 200
 (x + 1) * (sin(x)**2 + 1)**2 * cos(3*x)**3 = 0
 --R 
 --R
@@ -1403,7 +1403,7 @@ This equation is already factored and so {\sl should} be easy to solve
 --R                                            Type: Equation Expression Integer
 --E 71
 
---S 72 of 201
+--S 72 of 200
 solve(%, x)
 --R 
 --R
@@ -1417,7 +1417,7 @@ solve(%, x)
 The following equations have an infinite number of solutions (let $n$ be an
 arbitrary integer): $z = 0 [+ n 2 \pi i]$
 <<*>>=
---S 73 of 201
+--S 73 of 200
 solve(%e**z = 1, z)
 --R 
 --R
@@ -1428,7 +1428,7 @@ solve(%e**z = 1, z)
 @
 $x = \pi/4 [+ n \pi]$
 <<*>>=
---S 74 of 201
+--S 74 of 200
 solve(sin(x) = cos(x), x)
 --R 
 --R
@@ -1438,7 +1438,7 @@ solve(sin(x) = cos(x), x)
 --R                                       Type: List Equation Expression Integer
 --E 74
 
---S 75 of 201
+--S 75 of 200
 solve(tan(x) = 1, x)
 --R 
 --R
@@ -1451,7 +1451,7 @@ solve(tan(x) = 1, x)
 @
 $x = 0$, $0 [+ n \pi, + n 2 \pi]$
 <<*>>=
---S 76 of 201
+--S 76 of 200
 solve(sin(x) = tan(x), x)
 --R 
 --R
@@ -1462,7 +1462,7 @@ solve(sin(x) = tan(x), x)
 @
 This equation has no solutions
 <<*>>=
---S 77 of 201
+--S 77 of 200
 solve(sqrt(x**2 + 1) = x - 2, x)
 --R 
 --R
@@ -1473,7 +1473,7 @@ solve(sqrt(x**2 + 1) = x - 2, x)
 @
 Solve a system of linear equations
 <<*>>=
---S 78 of 201
+--S 78 of 200
 eq1:=   x +   y +   z =  6
 --R 
 --R
@@ -1481,7 +1481,7 @@ eq1:=   x +   y +   z =  6
 --R                                            Type: Equation Polynomial Integer
 --E 78
 
---S 79 of 201
+--S 79 of 200
 eq2:= 2*x +   y + 2*z = 10
 --R 
 --R
@@ -1489,7 +1489,7 @@ eq2:= 2*x +   y + 2*z = 10
 --R                                            Type: Equation Polynomial Integer
 --E 79
 
---S 80 of 201
+--S 80 of 200
 eq3:=   x + 3*y +   z = 10
 --R 
 --R
@@ -1500,17 +1500,17 @@ eq3:=   x + 3*y +   z = 10
 @
 Note that the solution is parametric
 <<*>>=
---S 81 of 201
+--S 81 of 200
 solve([eq1, eq2, eq3], [x, y, z])
 --R 
 --R
---R   (81)  [[x= - %BU + 4,y= 2,z= %BU]]
+--I   (81)  [[x= - %BU + 4,y= 2,z= %BU]]
 --R                         Type: List List Equation Fraction Polynomial Integer
 --E 81
 @
 Solve a system of nonlinear equations
 <<*>>=
---S 82 of 201
+--S 82 of 200
 eq1:= x**2*y + 3*y*z - 4 = 0
 --R 
 --R
@@ -1519,7 +1519,7 @@ eq1:= x**2*y + 3*y*z - 4 = 0
 --R                                            Type: Equation Polynomial Integer
 --E 82
 
---S 83 of 201
+--S 83 of 200
 eq2:= -3*x**2*z + 2*y**2 + 1 = 0
 --R 
 --R
@@ -1528,7 +1528,7 @@ eq2:= -3*x**2*z + 2*y**2 + 1 = 0
 --R                                            Type: Equation Polynomial Integer
 --E 83
 
---S 84 of 201
+--S 84 of 200
 eq3:= 2*y*z**2 - z**2 - 1 = 0
 --R 
 --R
@@ -1540,7 +1540,7 @@ eq3:= 2*y*z**2 - z**2 - 1 = 0
 @
 Solving this by hand would be a nightmare
 <<*>>=
---S 85 of 201
+--S 85 of 200
 solve([eq1, eq2, eq3], [x, y, z])
 --R 
 --R
@@ -1562,7 +1562,7 @@ solve([eq1, eq2, eq3], [x, y, z])
 @
 \section{Matrix Algebra}
 <<*>>=
---S 86 of 201
+--S 86 of 200
 m:= matrix([[a, b], [1, a*b]])
 --R 
 --R
@@ -1575,7 +1575,7 @@ m:= matrix([[a, b], [1, a*b]])
 @
 Invert the matrix
 <<*>>=
---S 87 of 201
+--S 87 of 200
 minv:= inverse(m)
 --R 
 --R
@@ -1591,7 +1591,7 @@ minv:= inverse(m)
 --R                          Type: Union(Matrix Fraction Polynomial Integer,...)
 --E 87
 
---S 88 of 201
+--S 88 of 200
 m * minv
 --R 
 --R
@@ -1604,7 +1604,7 @@ m * minv
 @
 Define a Vandermonde matrix (useful for doing polynomial interpolations)
 <<*>>=
---S 89 of 201
+--S 89 of 200
 matrix([[1,    1,    1,    1   ], _
         [w,    x,    y,    z   ], _
         [w**2, x**2, y**2, z**2], _
@@ -1623,7 +1623,7 @@ matrix([[1,    1,    1,    1   ], _
 --R                                              Type: Matrix Polynomial Integer
 --E 89
 
---S 90 of 201
+--S 90 of 200
 determinant(%)
 --R 
 --R
@@ -1645,7 +1645,7 @@ determinant(%)
 @
 The following formula implies a general result
 <<*>>=
---S 91 of 201
+--S 91 of 200
 factor(%)
 --R 
 --R
@@ -1656,7 +1656,7 @@ factor(%)
 @
 Compute the eigenvalues of a matrix from its characteristic polynomial
 <<*>>=
---S 92 of 201
+--S 92 of 200
 m:= matrix([[ 5, -3, -7], _
             [-2,  1,  2], _
             [ 2, -3, -4]])
@@ -1670,7 +1670,7 @@ m:= matrix([[ 5, -3, -7], _
 --R                                                         Type: Matrix Integer
 --E 92
 
---S 93 of 201
+--S 93 of 200
 characteristicPolynomial(m, lambda)
 --R 
 --R
@@ -1679,7 +1679,7 @@ characteristicPolynomial(m, lambda)
 --R                                                     Type: Polynomial Integer
 --E 93
 
---S 94 of 201
+--S 94 of 200
 solve(% = 0, lambda)
 --R 
 --R
@@ -1687,7 +1687,7 @@ solve(% = 0, lambda)
 --R                              Type: List Equation Fraction Polynomial Integer
 --E 94
 
---S 95 of 201
+--S 95 of 200
 m:= 'm;
 --R 
 --R
@@ -1698,7 +1698,7 @@ m:= 'm;
 \section{Sums and Products}
 \subsection{Sums: finite and infinite}
 <<*>>=
---S 96 of 201
+--S 96 of 200
 summation(k**3, k = 1..n)
 --R 
 --R
@@ -1710,7 +1710,7 @@ summation(k**3, k = 1..n)
 --R                                                     Type: Expression Integer
 --E 96
 
---S 97 of 201
+--S 97 of 200
 sum(k**3, k = 1..n)
 --R 
 --R
@@ -1721,7 +1721,7 @@ sum(k**3, k = 1..n)
 --R                                            Type: Fraction Polynomial Integer
 --E 97
 
---S 98 of 201
+--S 98 of 200
 limit(sum(1/k**2 + 1/k**3, k = 1..n), n = %plusInfinity)
 --R 
 --R
@@ -1731,7 +1731,7 @@ limit(sum(1/k**2 + 1/k**3, k = 1..n), n = %plusInfinity)
 @
 \subsection{Products}
 <<*>>=
---S 99 of 201
+--S 99 of 200
 product(k, k = 1..n)
 --R 
 --R
@@ -1747,7 +1747,7 @@ product(k, k = 1..n)
 \section{Calculus}
 \subsection{Limits --- start with a famous example}
 <<*>>=
---S 100 of 201
+--S 100 of 200
 limit((1 + 1/n)**n, n = %plusInfinity)
 --R 
 --R
@@ -1755,7 +1755,7 @@ limit((1 + 1/n)**n, n = %plusInfinity)
 --R                        Type: Union(OrderedCompletion Expression Integer,...)
 --E 100
 
---S 101 of 201
+--S 101 of 200
 limit((1 - cos(x))/x**2, x = 0)
 --R 
 --R
@@ -1769,21 +1769,21 @@ limit((1 - cos(x))/x**2, x = 0)
 Apply the chain rule---this is important for PDEs and many other
 applications
 <<*>>=
---S 102 of 201
+--S 102 of 200
 y:= operator('y);
 --R 
 --R
 --R                                                          Type: BasicOperator
 --E 102
 
---S 103 of 201
+--S 103 of 200
 x:= operator('x);
 --R 
 --R
 --R                                                          Type: BasicOperator
 --E 103
 
---S 104 of 201
+--S 104 of 200
 D(y(x(t)), t, 2)
 --R 
 --R
@@ -1798,7 +1798,7 @@ D(y(x(t)), t, 2)
 @
 \subsection{Indefinite Integrals}
 <<*>>=
---S 105 of 201
+--S 105 of 200
 1/(x**3 + 2)
 --R 
 --R
@@ -1812,7 +1812,7 @@ D(y(x(t)), t, 2)
 @
 This would be very difficult to do by hand
 <<*>>=
---S 106 of 201
+--S 106 of 200
 integrate(%, x)
 --R 
 --R
@@ -1830,7 +1830,7 @@ integrate(%, x)
 --R                                          Type: Union(Expression Integer,...)
 --E 106
 
---S 107 of 201
+--S 107 of 200
 D(%, x)
 --R 
 --R
@@ -1844,7 +1844,7 @@ D(%, x)
 @
 This example involves several symbolic parameters
 <<*>>=
---S 108 of 201
+--S 108 of 200
 integrate(1/(a + b*cos(x)), x)
 --R 
 --R
@@ -1870,7 +1870,7 @@ integrate(1/(a + b*cos(x)), x)
 --R                                     Type: Union(List Expression Integer,...)
 --E 108
 
---S 109 of 201
+--S 109 of 200
 map(simplify, map(f +-> D(f, x), %))
 --R 
 --R
@@ -1883,7 +1883,7 @@ map(simplify, map(f +-> D(f, x), %))
 @
 Calculus on a non-smooth (but well defined) function
 <<*>>=
---S 110 of 201
+--S 110 of 200
 D(abs(x), x)
 --R 
 --R
@@ -1893,13 +1893,13 @@ D(abs(x), x)
 --R                                                     Type: Expression Integer
 --E 110
 
---S 111 of 201
+--S 111 of 200
 integrate(abs(x), x)
 --R 
 --R
 --R             x
 --R           ++
---R   (111)   |   abs(%J)d%J
+--I   (111)   |   abs(%J)d%J
 --R          ++
 --R                                          Type: Union(Expression Integer,...)
 --E 111
@@ -1907,13 +1907,13 @@ integrate(abs(x), x)
 @
 Calculus on a piecewise defined function
 <<*>>=
---S 112 of 201
+--S 112 of 200
 a(x) == if x < 0 then -x else x
 --R 
 --R                                                                   Type: Void
 --E 112
 
---S 113 of 201
+--S 113 of 200
 D(a(x), x)
 --R 
 --R   Compiling function a with type Variable x -> Polynomial Integer 
@@ -1922,7 +1922,7 @@ D(a(x), x)
 --R                                                     Type: Polynomial Integer
 --E 113
 
---S 114 of 201
+--S 114 of 200
 integrate(a(x), x)
 --R 
 --R
@@ -1938,7 +1938,7 @@ integrate(a(x), x)
 The following two integrals should be equivalent.  The correct solution is
 $[(1 + x)^(3/2) + (1 - x)^(3/2)] / 3$
 <<*>>=
---S 115 of 201
+--S 115 of 200
 integrate(x/(sqrt(1 + x) + sqrt(1 - x)), x)
 --R 
 --R
@@ -1949,7 +1949,7 @@ integrate(x/(sqrt(1 + x) + sqrt(1 - x)), x)
 --R                                          Type: Union(Expression Integer,...)
 --E 115
 
---S 116 of 201
+--S 116 of 200
 integrate((sqrt(1 + x) - sqrt(1 - x))/2, x)
 --R 
 --R
@@ -1964,7 +1964,7 @@ integrate((sqrt(1 + x) - sqrt(1 - x))/2, x)
 \subsection{Definite Integrals}
 The following two functions have a pole at zero
 <<*>>=
---S 117 of 201
+--S 117 of 200
 integrate(1/x, x = -1..1)
 --R 
 --R 
@@ -1976,7 +1976,7 @@ integrate(1/x, x = -1..1)
 --R
 --E 117
 
---S 118 of 201
+--S 118 of 200
 integrate(1/x**2, x = -1..1)
 --R 
 --R 
@@ -1993,7 +1993,7 @@ Different branches of the square root need to be chosen in the intervals
 [0, 1] and [1, 2].  The correct results are $4/3$, $[4 - \sqrt{(8)}]/3$,
 $[8 - \sqrt{(8)}]/3$, respectively.
 <<*>>=
---S 119 of 201
+--S 119 of 200
 integrate(sqrt(x + 1/x - 2), x = 0..1)
 --R 
 --R
@@ -2001,7 +2001,7 @@ integrate(sqrt(x + 1/x - 2), x = 0..1)
 --R                                         Type: Union(pole: potentialPole,...)
 --E 119
 
---S 120 of 201
+--S 120 of 200
 integrate(sqrt(x + 1/x - 2), x = 0..1, "noPole")
 --R 
 --R
@@ -2011,7 +2011,7 @@ integrate(sqrt(x + 1/x - 2), x = 0..1, "noPole")
 --R                    Type: Union(f1: OrderedCompletion Expression Integer,...)
 --E 120
 
---S 121 of 201
+--S 121 of 200
 integrate(sqrt(x + 1/x - 2), x = 1..2)
 --R 
 --R
@@ -2019,7 +2019,7 @@ integrate(sqrt(x + 1/x - 2), x = 1..2)
 --R                                         Type: Union(pole: potentialPole,...)
 --E 121
 
---S 122 of 201
+--S 122 of 200
 integrate(sqrt(x + 1/x - 2), x = 1..2, "noPole")
 --R 
 --R
@@ -2030,7 +2030,7 @@ integrate(sqrt(x + 1/x - 2), x = 1..2, "noPole")
 --R                    Type: Union(f1: OrderedCompletion Expression Integer,...)
 --E 122
 
---S 123 of 201
+--S 123 of 200
 integrate(sqrt(x + 1/x - 2), x = 0..2)
 --R 
 --R
@@ -2038,7 +2038,7 @@ integrate(sqrt(x + 1/x - 2), x = 0..2)
 --R                                         Type: Union(pole: potentialPole,...)
 --E 123
 
---S 124 of 201
+--S 124 of 200
 integrate(sqrt(x + 1/x - 2), x = 0..2, "noPole")
 --R 
 --R
@@ -2052,7 +2052,7 @@ integrate(sqrt(x + 1/x - 2), x = 0..2, "noPole")
 @
 \subsection{Contour integrals}
 <<*>>=
---S 125 of 201
+--S 125 of 200
 integrate(cos(x)/(x**2 + a**2), x = %minusInfinity..%plusInfinity)
 --R 
 --R
@@ -2060,7 +2060,7 @@ integrate(cos(x)/(x**2 + a**2), x = %minusInfinity..%plusInfinity)
 --R                                         Type: Union(pole: potentialPole,...)
 --E 125
 
---S 126 of 201
+--S 126 of 200
 integrate(cos(x)/(x**2 + a**2), x = %minusInfinity..%plusInfinity, "noPole")
 --R 
 --R
@@ -2071,7 +2071,7 @@ integrate(cos(x)/(x**2 + a**2), x = %minusInfinity..%plusInfinity, "noPole")
 @
 \subsection{Integrand with a branch point}
 <<*>>=
---S 127 of 201
+--S 127 of 200
 integrate(t**(a - 1)/(1 + t), t = 0..%plusInfinity)
 --R 
 --R
@@ -2079,7 +2079,7 @@ integrate(t**(a - 1)/(1 + t), t = 0..%plusInfinity)
 --R                                         Type: Union(pole: potentialPole,...)
 --E 127
 
---S 128 of 201
+--S 128 of 200
 integrate(t**(a - 1)/(1 + t), t = 0..%plusInfinity, "noPole")
 --R 
 --R
@@ -2090,7 +2090,7 @@ integrate(t**(a - 1)/(1 + t), t = 0..%plusInfinity, "noPole")
 @
 Multiple integrals: volume of a tetrahedron
 <<*>>=
---S 129 of 201
+--S 129 of 200
 integrate(integrate(integrate(1, z = 0..c*(1 - x/a - y/b)), _
                     y = 0..b*(1 - x/a)), _
           x = 0..a)
@@ -2106,7 +2106,7 @@ integrate(integrate(integrate(1, z = 0..c*(1 - x/a - y/b)), _
 \subsection{Series}
 Taylor series---this first example comes from special relativity
 <<*>>=
---S 130 of 201
+--S 130 of 200
 1/sqrt(1 - (v/c)**2)
 --R 
 --R
@@ -2121,7 +2121,7 @@ Taylor series---this first example comes from special relativity
 --R                                                     Type: Expression Integer
 --E 130
 
---S 131 of 201
+--S 131 of 200
 series(%, v = 0)
 --R 
 --R
@@ -2132,7 +2132,7 @@ series(%, v = 0)
 --R                        Type: UnivariatePuiseuxSeries(Expression Integer,v,0)
 --E 131
 
---S 132 of 201
+--S 132 of 200
 1/%**2
 --R 
 --R
@@ -2143,7 +2143,7 @@ series(%, v = 0)
 --R                        Type: UnivariatePuiseuxSeries(Expression Integer,v,0)
 --E 132
 
---S 133 of 201
+--S 133 of 200
 tsin:= series(sin(x), x = 0)
 --R 
 --R
@@ -2153,7 +2153,7 @@ tsin:= series(sin(x), x = 0)
 --R                        Type: UnivariatePuiseuxSeries(Expression Integer,x,0)
 --E 133 
 
---S 134 of 201
+--S 134 of 200
 tcos:= series(cos(x), x = 0)
 --R 
 --R
@@ -2166,7 +2166,7 @@ tcos:= series(cos(x), x = 0)
 @
 Note that additional terms will be computed as needed
 <<*>>=
---S 135 of 201
+--S 135 of 200
 tsin/tcos
 --R 
 --R
@@ -2176,7 +2176,7 @@ tsin/tcos
 --R                        Type: UnivariatePuiseuxSeries(Expression Integer,x,0)
 --E 135
 
---S 136 of 201
+--S 136 of 200
 series(tan(x), x = 0)
 --R 
 --R
@@ -2192,7 +2192,7 @@ Look at the Taylor series around $x = 1$
 
 )set streams calculate 1
 
---S 137  of 201
+--S 137 of 200
 log(x)**a*exp(-b*x)
 --R 
 --R
@@ -2201,7 +2201,7 @@ log(x)**a*exp(-b*x)
 --R                                                     Type: Expression Integer
 --E 137
 
---S 138 of 201
+--S 138 of 200
 series(%, x = 1)
 --R 
 --R 
@@ -2218,7 +2218,7 @@ series(%, x = 1)
 @ 
 Compare the Taylor series of two different formulations of a function
 <<*>>=
---S 139 of 201
+--S 139 of 200
 taylor(log(sinh(z)) + log(cosh(z + w)), z = 0)
 --R 
 --R 
@@ -2230,7 +2230,7 @@ taylor(log(sinh(z)) + log(cosh(z + w)), z = 0)
 --R
 --E 139
 
---S 140 of 201
+--S 140 of 200
 % - taylor(log(sinh(z) * cosh(z + w)), z = 0)
 --R 
 --R 
@@ -2246,7 +2246,7 @@ taylor(log(sinh(z)) + log(cosh(z + w)), z = 0)
 \subsection{Power series}
 Compute the general formula
 <<*>>=
---S 141 of 201
+--S 141 of 200
 log(sin(x)/x)
 --R 
 --R
@@ -2256,7 +2256,7 @@ log(sin(x)/x)
 --R                                                     Type: Expression Integer
 --E 141
 
---S 142 of 201
+--S 142 of 200
 series(%, x = 0)
 --R 
 --R
@@ -2266,7 +2266,7 @@ series(%, x = 0)
 --R                        Type: UnivariatePuiseuxSeries(Expression Integer,x,0)
 --E 142
 
---S 143 of 201
+--S 143 of 200
 exp(-x)*sin(x)
 --R 
 --R
@@ -2275,7 +2275,7 @@ exp(-x)*sin(x)
 --R                                                     Type: Expression Integer
 --E 143
 
---S 144 of 201
+--S 144 of 200
 series(%, x = 0)
 --R 
 --R
@@ -2289,14 +2289,14 @@ series(%, x = 0)
 Derive an explicit Taylor series solution of y as a function of x from the
 following implicit relation
 <<*>>=
---S 145 of 201
+--S 145 of 200
 y:= operator('y);
 --R 
 --R
 --R                                                          Type: BasicOperator
 --E 145
 
---S 146 of 201
+--S 146 of 200
 x = sin(y(x)) + cos(y(x))
 --R 
 --R
@@ -2304,7 +2304,7 @@ x = sin(y(x)) + cos(y(x))
 --R                                            Type: Equation Expression Integer
 --E 146
 
---S 147 of 201
+--S 147 of 200
 seriesSolve(%, y, x = 1, 0)
 --R 
 --R 
@@ -2321,7 +2321,7 @@ seriesSolve(%, y, x = 1, 0)
 @ 
 \subsection{Pade (rational function) approximation}
 <<*>>=
---S 148 of 201
+--S 148 of 200
 pade(1, 1, taylor(exp(-x), x = 0))
 --R 
 --R
@@ -2335,7 +2335,7 @@ pade(1, 1, taylor(exp(-x), x = 0))
 \section{Transforms}
 \subsection{Laplace and inverse Laplace transforms}
 <<*>>=
---S 149 of 201
+--S 149 of 200
 laplace(cos((w - 1)*t), t, s)
 --R 
 --R
@@ -2346,7 +2346,7 @@ laplace(cos((w - 1)*t), t, s)
 --R                                                     Type: Expression Integer
 --E 149
 
---S 150 of 201
+--S 150 of 200
 inverseLaplace(%, s, t)
 --R 
 --R
@@ -2360,14 +2360,14 @@ inverseLaplace(%, s, t)
 \section{Difference and Differential Equations}
 \subsection{Second order linear recurrence equation}
 <<*>>=
---S 151 of 201
+--S 151 of 200
 r:= operator('r);
 --R 
 --R
 --R                                                          Type: BasicOperator
 --E 151
 
---S 152 of 201
+--S 152 of 200
 r(n + 2) - 2 * r(n + 1) + r(n) = 2
 --R 
 --R
@@ -2375,7 +2375,7 @@ r(n + 2) - 2 * r(n + 1) + r(n) = 2
 --R                                            Type: Equation Expression Integer
 --E 152
 
---S 153 of 201
+--S 153 of 200
 [%, r(0) = 1, r(1) = m]
 --R 
 --R
@@ -2389,14 +2389,14 @@ r(n + 2) - 2 * r(n + 1) + r(n) = 2
 \subsection{Second order ODE with initial conditions}
 solve first using Laplace transforms
 <<*>>=
---S 154 of 201
+--S 154 of 200
 f:= operator('f);
 --R 
 --R
 --R                                                          Type: BasicOperator
 --E 154
 
---S 155 of 201
+--S 155 of 200
 ode:= D(f(t), t, 2) + 4*f(t) = sin(2*t)
 --R 
 --R
@@ -2406,7 +2406,7 @@ ode:= D(f(t), t, 2) + 4*f(t) = sin(2*t)
 --R                                            Type: Equation Expression Integer
 --E 155
 
---S 156 of 201
+--S 156 of 200
 map(e +-> laplace(e, t, s), %)
 --R 
 --R
@@ -2420,7 +2420,7 @@ map(e +-> laplace(e, t, s), %)
 @
 Now, solve the ODE directly
 <<*>>=
---S 157 of 201
+--S 157 of 200
 solve(ode, f, t = 0, [0, 0])
 --R 
 --R
@@ -2433,14 +2433,14 @@ solve(ode, f, t = 0, [0, 0])
 @
 \subsection{First order linear ODE}
 <<*>>=
---S 158 of 201
+--S 158 of 200
 y:= operator('y);
 --R 
 --R
 --R                                                          Type: BasicOperator
 --E 158
 
---S 159 of 201
+--S 159 of 200
 x**2 * D(y(x), x) + 3*x*y(x) = sin(x)/x
 --R 
 --R
@@ -2450,7 +2450,7 @@ x**2 * D(y(x), x) + 3*x*y(x) = sin(x)/x
 --R                                            Type: Equation Expression Integer
 --E 159
 
---S 160 of 201
+--S 160 of 200
 solve(%, y, x)
 --R 
 --R
@@ -2464,7 +2464,7 @@ solve(%, y, x)
 @
 \subsection{Nonlinear ODE}
 <<*>>=
---S 161 of 201
+--S 161 of 200
 D(y(x), x, 2) + y(x)*D(y(x), x)**3 = 0
 --R 
 --R
@@ -2474,7 +2474,7 @@ D(y(x), x, 2) + y(x)*D(y(x), x)**3 = 0
 --R                                            Type: Equation Expression Integer
 --E 161
 
---S 162 of 201
+--S 162 of 200
 solve(%, y, x)
 --R 
 --R 
@@ -2489,7 +2489,7 @@ solve(%, y, x)
 @
 A simple parametric ODE
 <<*>>=
---S 163 of 201
+--S 163 of 200
 D(y(x, a), x) = a*y(x, a)
 --R 
 --R
@@ -2498,7 +2498,7 @@ D(y(x, a), x) = a*y(x, a)
 --R                                            Type: Equation Expression Integer
 --E 163
 
---S 164 of 201
+--S 164 of 200
 solve(%, y, x);
 --R 
 --R 
@@ -2515,7 +2515,7 @@ solve(%, y, x);
 This problem has nontrivial solutions
 $y(x) = A \sin([\pi/2 + n \pi] x)$ for $n$ an arbitrary integer.
 <<*>>=
---S 165 of 201
+--S 165 of 200
 solve(D(y(x), x, 2) + k**2*y(x) = 0, y, x)
 --R 
 --R
@@ -2528,14 +2528,14 @@ solve(D(y(x), x, 2) + k**2*y(x) = 0, y, x)
 @
 \subsection{System of two linear, constant coefficient ODEs}
 <<*>>=
---S 166 of 201
+--S 166 of 200
 x:= operator('x);
 --R 
 --R
 --R                                                          Type: BasicOperator
 --E 166
 
---S 167 of 201
+--S 167 of 200
 system:= [D(x(t), t) = x(t) - y(t), D(y(t), t) = x(t) + y(t)]
 --R 
 --R
@@ -2548,7 +2548,7 @@ system:= [D(x(t), t) = x(t) - y(t), D(y(t), t) = x(t) + y(t)]
 @
 Check the answer. Triangular system of two ODEs
 <<*>>=
---S 168 of 201
+--S 168 of 200
 system:= [D(x(t), t) = x(t) * (1 + cos(t)/(2 + sin(t))), _
           D(y(t), t) = x(t) - y(t)]
 --R 
@@ -2562,8 +2562,8 @@ system:= [D(x(t), t) = x(t) * (1 + cos(t)/(2 + sin(t))), _
 @
 Try solving this system one equation at a time
 <<*>>=
---S 169 of 201
-solve(system.1, x, t)
+--S 169 of 200
+s:=solve(system.1, x, t)
 --R 
 --R
 --R                                   t            t
@@ -2571,185 +2571,125 @@ solve(system.1, x, t)
 --RType: Union(Record(particular: Expression Integer,basis: List Expression Integer),...)
 --E 169
 
---S 170 of 201
-isTimes(subst(%.basis.1, cos(t) = sqrt(1 - sin(t)**2)))
+--S 170 of 200
+eq1 := x(t) = C1 * s.basis.1
 --R 
 --R
---R   (162)  "failed"
---R                                                    Type: Union("failed",...)
+--R                     t               t
+--R   (162)  x(t)= C1 %e sin(t) + 2C1 %e
+--R                                            Type: Equation Expression Integer
 --E 170
 
---S 171 of 201
-reduce(*, cons(subst(
-   factors(factor(subst(%.1**2, sin(t) = u) :: Polynomial Integer)).1.factor,
-                     u = sin(t)),
-               rest(%)))
---R 
---R   There are 30 exposed and 3 unexposed library operations named elt 
---R      having 2 argument(s) but none was determined to be applicable. 
---R      Use HyperDoc Browse, or issue
---R                               )display op elt
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
+--S 171 of 200
+s1:=solve(map(e +-> subst(e, eq1), system.2), y, t)
 --R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named elt 
---R      with argument type(s) 
---R                                   failed
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R
+--R   (163)
+--R                      - t   t 2                              - t   t 2
+--R                2C1 %e   (%e ) sin(t) + (- C1 cos(t) + 5C1)%e   (%e )
+--R   [particular= ------------------------------------------------------,
+--R                                           5
+--R              - t
+--R    basis= [%e   ]]
+--RType: Union(Record(particular: Expression Integer,basis: List Expression Integer),...)
 --E 171
 
---S 172 of 201
-x(t) = C1 * %
---R 
---R   There are 34 exposed and 23 unexposed library operations named * 
---R      having 2 argument(s) but none was determined to be applicable. 
---R      Use HyperDoc Browse, or issue
---R                                )display op *
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
+--S 172 of 200
+eq2 := y(t) = simplify(s1.particular) + C2 * s1.basis.1
 --R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named * 
---R      with argument type(s) 
---R                                 Variable C1
---R                                   failed
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R
+--R                      t                              t         - t
+--R                2C1 %e sin(t) + (- C1 cos(t) + 5C1)%e  + 5C2 %e
+--R   (164)  y(t)= --------------------------------------------------
+--R                                         5
+--R                                            Type: Equation Expression Integer
 --E 172
 
---S 173 of 201
-solve(map(e +-> subst(e, %), system.2), y, t)
---R 
---R   There are 3 exposed and 0 unexposed library operations named subst 
---R      having 2 argument(s) but none was determined to be applicable. 
---R      Use HyperDoc Browse, or issue
---R                              )display op subst
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
---R   Cannot find a definition or applicable library operation named subst
---R      with argument type(s) 
---R                             Expression Integer
---R                   Union(List Expression Integer,"failed")
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
---R   AXIOM will attempt to step through and interpret the code.
+--S 173 of 200
+map(e +-> rightZero eval(e, [eq1, D(eq1,t), eq2 , D(eq2,t)]), system)
 --R 
---RDaly Bug
---R   Anonymous user functions created with +-> that are processed in 
---R      interpret-code mode must have result target information 
---R      available. This information is not present so AXIOM cannot 
---R      proceed any further. This may be remedied by declaring the 
---R      function.
+--R
+--R   (165)  [0= 0,0= 0]
+--R                                       Type: List Equation Expression Integer
 --E 173
-
---S 174 of 201
-y(t) = simplify(%.particular) + C2 * %.basis.1
---R 
---R   There are 30 exposed and 3 unexposed library operations named elt 
---R      having 2 argument(s) but none was determined to be applicable. 
---R      Use HyperDoc Browse, or issue
---R                               )display op elt
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named elt 
---R      with argument type(s) 
---R                                   failed
---R                             Variable particular
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
---E 174
-
 )clear properties x y
  
 @
 \section{Operators}
 \subsection{Linear differential operator}
 <<*>>=
---S 175 of 201
+--S 174 of 200
 DD:= operator("D") :: Operator(Expression Integer)
 --R 
 --R
---R   (163)  D
+--R   (166)  D
 --R                                            Type: Operator Expression Integer
---E 175
+--E 174
 
---S 176 of 201
+--S 175 of 200
 evaluate(DD, e +-> D(e, x))$Operator(Expression Integer)
 --R 
 --R
---R   (164)  D
+--R   (167)  D
 --R                                            Type: Operator Expression Integer
---E 176
+--E 175
 
---S 177 of 201
+--S 176 of 200
 L:= (DD - 1) * (DD + 2)
 --R 
 --R
 --R                 2
---R   (165)  D 2 + D  - D - 2
+--R   (168)  D 2 + D  - D - 2
 --R                                            Type: Operator Expression Integer
---E 177
+--E 176
 
---S 178 of 201
+--S 177 of 200
 g:= operator('g)
 --R 
 --R
---R   (166)  g
+--R   (169)  g
 --R                                                          Type: BasicOperator
---E 178
+--E 177
 
---S 179 of 201
+--S 178 of 200
 L(f(x))
 --R 
 --R
 --R           ,,       ,
---R   (167)  f  (x) + f (x) - 2f(x)
+--R   (170)  f  (x) + f (x) - 2f(x)
 --R
 --R                                                     Type: Expression Integer
---E 179
+--E 178
 
---S 180 of 201
+--S 179 of 200
 subst(L(subst(g(y), y = x)), x = y)
 --R 
 --R
 --R           ,,       ,
---R   (168)  g  (y) + g (y) - 2g(y)
+--R   (171)  g  (y) + g (y) - 2g(y)
 --R
 --R                                                     Type: Expression Integer
---E 180
+--E 179
 
---S 181 of 201
+--S 180 of 200
 subst(L(subst(A * sin(z**2), z = x)), x = z)
 --R 
 --R
 --R                 2           2                    2
---R   (169)  (- 4A z  - 2A)sin(z ) + (2A z + 2A)cos(z )
+--R   (172)  (- 4A z  - 2A)sin(z ) + (2A z + 2A)cos(z )
 --R                                                     Type: Expression Integer
---E 181
+--E 180
 
 @
 \subsection{Truncated Taylor series operator}
 <<*>>=
---S 182 of 201
+--S 181 of 200
 T:= (f, xx, a) +-> subst((DD**0)(f(x)), x = a)/factorial(0) * (xx - a)**0 + _
                    subst((DD**1)(f(x)), x = a)/factorial(1) * (xx - a)**1 + _
                    subst((DD**2)(f(x)), x = a)/factorial(2) * (xx - a)**2
 --R 
 --R
---R   (170)
+--R   (173)
 --R     (f,xx,a)
 --R   +-> 
 --R               0                                 1
@@ -2762,70 +2702,70 @@ T:= (f, xx, a) +-> subst((DD**0)(f(x)), x = a)/factorial(0) * (xx - a)**0 + _
 --R       --------------------- (xx - a)
 --R            factorial(2)
 --R                                                      Type: AnonymousFunction
---E 182
+--E 181
 
---S 183 of 201
+--S 182 of 200
 T(f, x, a)
 --R 
 --R
 --R            2           2  ,,                ,
 --R          (x  - 2a x + a )f  (a) + (2x - 2a)f (a) + 2f(a)
 --R
---R   (171)  -----------------------------------------------
+--R   (174)  -----------------------------------------------
 --R                                 2
 --R                                                     Type: Expression Integer
---E 183
+--E 182
 
---S 184 of 201
+--S 183 of 200
 T(g, y, b)
 --R 
 --R
 --R            2           2  ,,                ,
 --R          (y  - 2b y + b )g  (b) + (2y - 2b)g (b) + 2g(b)
 --R
---R   (172)  -----------------------------------------------
+--R   (175)  -----------------------------------------------
 --R                                 2
 --R                                                     Type: Expression Integer
---E 184
+--E 183
 
---S 185 of 201
+--S 184 of 200
 Sin:= operator("sin") :: Operator(Expression Integer)
 --R 
 --R
---R   (173)  sin
+--R   (176)  sin
 --R                                            Type: Operator Expression Integer
---E 185
+--E 184
 
---S 186 of 201
+--S 185 of 200
 evaluate(Sin, x +-> sin(x))$Operator(Expression Integer)
 --R 
 --R
---R   (174)  sin
+--R   (177)  sin
 --R                                            Type: Operator Expression Integer
---E 186
+--E 185
 
---S 187 of 201
+--S 186 of 200
 T(Sin, z, c)
 --R 
 --R
 --R              2           2
 --R          (- z  + 2c z - c  + 2)sin(c) + (2z - 2c)cos(c)
---R   (175)  ----------------------------------------------
+--R   (178)  ----------------------------------------------
 --R                                 2
 --R                                                     Type: Expression Integer
---E 187
+--E 186
 
 @
 \section{Programming}
 Write a simple program to compute Legendre polynomials
 <<*>>=
---S 188 of 201
+--S 187 of 200
 p(n, x) == 1/(2**n*factorial(n)) * D((x**2 - 1)**n, x, n)
 --R 
 --R                                                                   Type: Void
---E 188
+--E 187
 
---S 189 of 201
+--S 188 of 200
 for i in 0..4 repeat {  output("");    output(concat(["p(", string(i), ", x) = "]));    output(p(i, x))}
 --R 
 --R   Compiling function p with type (NonNegativeInteger,Variable x) -> 
@@ -2852,40 +2792,40 @@ for i in 0..4 repeat {  output("");    output(concat(["p(", string(i), ", x) = "
 --R   -- x  - -- x  + -
 --R    8       4      8
 --R                                                                   Type: Void
---E 189
+--E 188
 
---S 190 of 201
+--S 189 of 200
 eval(p(4, x), x = 1)
 --R 
 --R   Compiling function p with type (PositiveInteger,Variable x) -> 
 --R      Polynomial Fraction Integer 
 --R
---R   (178)  1
+--R   (181)  1
 --R                                            Type: Polynomial Fraction Integer
---E 190
+--E 189
 
 @
 Now, perform the same computation using a recursive definition
 <<*>>=
---S 191 of 201
+--S 190 of 200
 pp(0, x) == 1
 --R 
 --R                                                                   Type: Void
---E 191
+--E 190
 
---S 192 of 201
+--S 191 of 200
 pp(1, x) == x
 --R 
 --R                                                                   Type: Void
---E 192
+--E 191
 
---S 193 of 201
+--S 192 of 200
 pp(n, x) == ((2*n - 1)*x*pp(n - 1, x) - (n - 1)*pp(n - 2, x))/n
 --R 
 --R                                                                   Type: Void
---E 193
+--E 192
 
---S 194 of 201
+--S 193 of 200
 for i in 0..4 repeat {   output("");   output(concat(["pp(", string(i), ", x) = "]));   output(pp(i, x))}
 --R 
 --R   Compiling function pp with type (Integer,Variable x) -> Polynomial 
@@ -2912,7 +2852,7 @@ for i in 0..4 repeat {   output("");   output(concat(["pp(", string(i), ", x) =
 --R   -- x  - -- x  + -
 --R    8       4      8
 --R                                                                   Type: Void
---E 194
+--E 193
 
 )clear properties p pp
 
@@ -2921,31 +2861,31 @@ for i in 0..4 repeat {   output("");   output(concat(["pp(", string(i), ", x) =
 \subsection{Horner's rule}
 This is important for numerical algorithms
 <<*>>=
---S 195 of 201
+--S 194 of 200
 a:= operator('a)
 --R 
 --R
---R   (183)  a
+--R   (186)  a
 --R                                                          Type: BasicOperator
---E 195
+--E 194
 
---S 196 of 201
+--S 195 of 200
 sum(a(i)*x**i, i = 1..5)
 --R 
 --R
 --R               5        4        3        2
---R   (184)  a(5)x  + a(4)x  + a(3)x  + a(2)x  + a(1)x
+--R   (187)  a(5)x  + a(4)x  + a(3)x  + a(2)x  + a(1)x
 --R                                                     Type: Expression Integer
---E 196
+--E 195
 
---S 197 of 201
+--S 196 of 200
 p:= factor(%)
 --R 
 --R
 --R               5        4        3        2
---R   (185)  a(5)x  + a(4)x  + a(3)x  + a(2)x  + a(1)x
+--R   (188)  a(5)x  + a(4)x  + a(3)x  + a(2)x  + a(1)x
 --R                                            Type: Factored Expression Integer
---E 197
+--E 196
 
 @
 Convert the result into FORTRAN syntax
@@ -2953,40 +2893,40 @@ Convert the result into FORTRAN syntax
 
 )set fortran ints2floats off
 
---S 198  of 201
+--S 197 of 200
 outputAsFortran('p = p)
 --R 
 --R      p=a(5)*x**5+a(4)*x**4+a(3)*x**3+a(2)*x*x+a(1)*x
 --R                                                                   Type: Void
---E 198
+--E 197
 
 @
 \section{Boolean Logic}
 \subsection{Simplify logical expressions}
 <<*>>=
---S 199 of 201
+--S 198 of 200
 true and false
 --R 
 --R
---R   (187)  false
+--R   (190)  false
 --R                                                                Type: Boolean
---E 199
+--E 198
 
---S 200 of 201
+--S 199 of 200
 x or (not x)
 --R 
 --R 
 --RDaly Bug
 --R   Argument number 1 to "or" must be a Boolean.
---E 200
+--E 199
 
---S 201 of 201
+--S 200 of 200
 x or y or (x and y)
 --R 
 --R 
 --RDaly Bug
 --R   Argument number 1 to "or" must be a Boolean.
---E 201
+--E 200
 )spool
 )lisp (bye)
  
diff --git a/src/input/exlap.input.pamphlet b/src/input/exlap.input.pamphlet
index 432b063..d290295 100644
--- a/src/input/exlap.input.pamphlet
+++ b/src/input/exlap.input.pamphlet
@@ -37,39 +37,31 @@ laplace((exp(a*t) - exp(b*t))/t, t, s)
 --E 2
 
 --S 3 of 6
-laplace(exp(a*t+b)*ei(c*t), t, s)
+laplace(exp(a*t+b)*Ei(c*t), t, s)
 --R 
---R   There are no library operations named ei 
---R      Use HyperDoc Browse or issue
---R                                 )what op ei
---R      to learn if there is any operation containing " ei " in its name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named ei 
---R      with argument type(s) 
---R                             Polynomial Integer
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R
+--R          b    s + c - a
+--R        %e log(---------)
+--R                   c
+--R   (3)  -----------------
+--R              s - a
+--R                                                     Type: Expression Integer
 --E 3
 
 )clear all
 
 --S 4 of 6
-laplace(a*ci(b*t) + c*si(d*t), t, s)
+laplace(a*Ci(b*t) + c*Si(d*t), t, s)
 --R 
---R   There are no library operations named ci 
---R      Use HyperDoc Browse or issue
---R                                 )what op ci
---R      to learn if there is any operation containing " ci " in its name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named ci 
---R      with argument type(s) 
---R                             Polynomial Integer
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R
+--R               2    2
+--R              s  + b             d
+--R        a log(-------) + 2c atan(-)
+--R                  2              s
+--R                 b
+--R   (1)  ---------------------------
+--R                     2s
+--R                                                     Type: Expression Integer
 --E 4
 
 )clear all
diff --git a/src/input/exsum.input.pamphlet b/src/input/exsum.input.pamphlet
index 7c2f9d0..df444c0 100644
--- a/src/input/exsum.input.pamphlet
+++ b/src/input/exsum.input.pamphlet
@@ -93,32 +93,19 @@ sum(3*k**2/(c**2 + 1) + 12*k/d,k = (3*a)..(4*b))
 )clear all
 
 --S 7 of 13
-[1..15]
+[i for i in 1..15]
 --R 
 --R
---R   (1)  [1..15]
---R                                           Type: List Segment PositiveInteger
+--R   (1)  [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15]
+--R                                                   Type: List PositiveInteger
 --E 7
 
 --S 8 of 13
-reduce(+,[1..15])
---R 
---R   There are 1 exposed and 3 unexposed library operations named reduce 
---R      having 2 argument(s) but none was determined to be applicable. 
---R      Use HyperDoc Browse, or issue
---R                             )display op reduce
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
+reduce(+,[i for i in 1..15])
 --R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      reduce with argument type(s) 
---R                                 Variable +
---R                        List Segment PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R
+--R   (2)  120
+--R                                                        Type: PositiveInteger
 --E 8
 
 )clear all
diff --git a/src/input/grpthry.input.pamphlet b/src/input/grpthry.input.pamphlet
index 544b278..b0296a4 100644
--- a/src/input/grpthry.input.pamphlet
+++ b/src/input/grpthry.input.pamphlet
@@ -19,7 +19,7 @@
 )set message auto off
 )clear all
  
---S 1 of 67
+--S 1 of 68
 x : PERM INT := [[1,3,5],[7,11,9]]
 --R 
 --R
@@ -27,7 +27,7 @@ x : PERM INT := [[1,3,5],[7,11,9]]
 --R                                                    Type: Permutation Integer
 --E 1
 
---S 2 of 67
+--S 2 of 68
 y : PERM INT := [[3,5,7,9]]
 --R 
 --R
@@ -35,7 +35,7 @@ y : PERM INT := [[3,5,7,9]]
 --R                                                    Type: Permutation Integer
 --E 2
 
---S 3 of 67
+--S 3 of 68
 z : PERM INT := [1,3,11]
 --R 
 --R
@@ -43,155 +43,113 @@ z : PERM INT := [1,3,11]
 --R                                                    Type: Permutation Integer
 --E 3
 
---S 4 of 67
-g1 : PERMGRPS INT := [ x , y ]
+--S 4 of 68
+g1 : PERMGRP INT := [ x , y ]
 --R 
---R 
---RDaly Bug
---R   Category, domain or package constructor PERMGRPS is not available.
+--R
+--R   (4)  <(1 3 5)(7 11 9),(3 5 7 9)>
+--R                                               Type: PermutationGroup Integer
 --E 4
 
---S 5 of 67
-g2 : PERMGRPS INT := [ x , z ]
+--S 5 of 68
+g2 : PERMGRP INT := [ x , z ]
 --R 
---R 
---RDaly Bug
---R   Category, domain or package constructor PERMGRPS is not available.
+--R
+--R   (5)  <(1 3 5)(7 11 9),(1 3 11)>
+--R                                               Type: PermutationGroup Integer
 --E 5
 
---S 6 of 67
-g3 : PERMGRPS INT := [ y , z ]
+--S 6 of 68
+g3 : PERMGRP INT := [ y , z ]
 --R 
---R 
---RDaly Bug
---R   Category, domain or package constructor PERMGRPS is not available.
+--R
+--R   (6)  <(3 5 7 9),(1 3 11)>
+--R                                               Type: PermutationGroup Integer
 --E 6
 
---S 7 of 67
+--S 7 of 68
 order g1
 --R 
---R   There are 9 exposed and 5 unexposed library operations named order 
---R      having 1 argument(s) but none was determined to be applicable. 
---R      Use HyperDoc Browse, or issue
---R                              )display op order
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named order
---R      with argument type(s) 
---R                                 Variable g1
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R
+--R   (7)  720
+--R                                                        Type: PositiveInteger
 --E 7
 
---S 8 of 67
+--S 8 of 68
 degree g3
 --R 
 --R
---R   (4)  g3
---R                                                Type: IndexedExponents Symbol
+--R   (8)  6
+--R                                                        Type: PositiveInteger
 --E 8
 
---S 9 of 67
+--S 9 of 68
 movedPoints g2
 --R 
---R   There are 2 exposed and 0 unexposed library operations named 
---R      movedPoints having 1 argument(s) but none was determined to be 
---R      applicable. Use HyperDoc Browse, or issue
---R                           )display op movedPoints
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      movedPoints with argument type(s) 
---R                                 Variable g2
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R
+--R   (9)  {1,3,5,7,9,11}
+--R                                                            Type: Set Integer
 --E 9
 
---S 10 of 67
+--S 10 of 68
 orbit (g1, 3)
 --R 
---R   There are 4 exposed and 0 unexposed library operations named orbit 
---R      having 2 argument(s) but none was determined to be applicable. 
---R      Use HyperDoc Browse, or issue
---R                              )display op orbit
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named orbit
---R      with argument type(s) 
---R                                 Variable g1
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R
+--R   (10)  {1,3,5,7,9,11}
+--R                                                            Type: Set Integer
 --E 10
 
---S 11 of 67
+--S 11 of 68
 orbits g3
 --R 
---R   There are 1 exposed and 0 unexposed library operations named orbits 
---R      having 1 argument(s) but none was determined to be applicable. 
---R      Use HyperDoc Browse, or issue
---R                             )display op orbits
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      orbits with argument type(s) 
---R                                 Variable g3
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R
+--R   (11)  {{1,3,5,7,9,11}}
+--R                                                        Type: Set Set Integer
 --E 11
 
---S 12 of 67
+--S 12 of 68
 member? ( y , g2 )
 --R 
---R   There are 2 exposed and 1 unexposed library operations named member?
---R      having 2 argument(s) but none was determined to be applicable. 
---R      Use HyperDoc Browse, or issue
---R                             )display op member?
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      member? with argument type(s) 
---R                             Permutation Integer
---R                                 Variable g2
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R
+--R   (12)  false
+--R                                                                Type: Boolean
 --E 12
 
---S 13 of 67
-)sh PERMGRPS
+--S 13 of 68
+)sh PERMGRP
 --R 
---R   The )show system command is used to display information about types 
---R      or partial types. For example, )show Integer will show 
---R      information about Integer .
---R   
---R      PERMGRPS is not the name of a known type constructor. If you want
---R      to see information about any operations named PERMGRPS , issue
---R                        )display operations PERMGRPS 
+--R PermutationGroup S: SetCategory  is a domain constructor
+--R Abbreviation for PermutationGroup is PERMGRP 
+--R This constructor is exposed in this frame.
+--R Issue )edit permgrps.spad.pamphlet to see algebra source code for PERMGRP 
+--R
+--R------------------------------- Operations --------------------------------
+--R ?<? : (%,%) -> Boolean                ?<=? : (%,%) -> Boolean
+--R ?=? : (%,%) -> Boolean                base : % -> List S
+--R coerce : List Permutation S -> %      coerce : % -> List Permutation S
+--R coerce : % -> OutputForm              degree : % -> NonNegativeInteger
+--R hash : % -> SingleInteger             latex : % -> String
+--R movedPoints : % -> Set S              orbit : (%,List S) -> Set List S
+--R orbit : (%,Set S) -> Set Set S        orbit : (%,S) -> Set S
+--R orbits : % -> Set Set S               order : % -> NonNegativeInteger
+--R random : % -> Permutation S           ?~=? : (%,%) -> Boolean
+--R ?.? : (%,NonNegativeInteger) -> Permutation S
+--R generators : % -> List Permutation S
+--R initializeGroupForWordProblem : (%,Integer,Integer) -> Void
+--R initializeGroupForWordProblem : % -> Void
+--R member? : (Permutation S,%) -> Boolean
+--R permutationGroup : List Permutation S -> %
+--R random : (%,Integer) -> Permutation S
+--R strongGenerators : % -> List Permutation S
+--R wordInGenerators : (Permutation S,%) -> List NonNegativeInteger
+--R wordInStrongGenerators : (Permutation S,%) -> List NonNegativeInteger
+--R wordsForStrongGenerators : % -> List List NonNegativeInteger
+--R
 --E 13
 
 )clear all
 
---S 14 of 67
+--S 14 of 68
 ptn9 := partitions 9
 --R 
 --R
@@ -200,112 +158,1133 @@ ptn9 := partitions 9
 --R                                                    Type: Stream List Integer
 --E 14
 
---S 15 of 67
-map(dimIrrRepSym, ptn9)
---R 
---R   There are 68 exposed and 8 unexposed library operations named map 
---R      having 2 argument(s) but none was determined to be applicable. 
---R      Use HyperDoc Browse, or issue
---R                               )display op map
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named map 
---R      with argument type(s) 
---R                            Variable dimIrrRepSym
---R                             Stream List Integer
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--S 15 of 68
+map(dimensionOfIrreducibleRepresentation, ptn9)
+--R 
+--R
+--R   (2)  [1,8,27,28,48,105,56,42,162,120,...]
+--R                                              Type: Stream NonNegativeInteger
 --E 15
 
---S 16 of 67
-yt := listYoungTableaus [4,2]; yt :: (LIST TABLEAU I)
---R 
+--S 16 of 68
+yt := listYoungTableaus [4,2]
 --R 
---RDaly Bug
---R   I is not a valid type.
+--R
+--R   (3)
+--R    +0  2  4  5+  +0  2  3  5+  +0  2  3  4+  +0  1  4  5+  +0  1  3  5+
+--R   [|          |, |          |, |          |, |          |, |          |,
+--R    +1  3  0  0+  +1  4  0  0+  +1  5  0  0+  +2  3  0  0+  +2  4  0  0+
+--R    +0  1  3  4+  +0  1  2  5+  +0  1  2  4+  +0  1  2  3+
+--R    |          |, |          |, |          |, |          |]
+--R    +2  5  0  0+  +3  4  0  0+  +3  5  0  0+  +4  5  0  0+
+--R                                                    Type: List Matrix Integer
 --E 16
 
---S 17 of 67
-r1 := irrRepSymNat([4,2],[1,2,4,5,3,6])
---R 
---R   There are no library operations named irrRepSymNat 
---R      Use HyperDoc Browse or issue
---R                            )what op irrRepSymNat
---R      to learn if there is any operation containing " irrRepSymNat " in
---R      its name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      irrRepSymNat with argument type(s) 
---R                            List PositiveInteger
---R                            List PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--S 17 of 68
+r1 := irreducibleRepresentation([4,2],[1,2,4,5,3,6])
+--R 
+--R
+--R        + 0   - 1  - 1   0    0    0    0    0    1 +
+--R        |                                           |
+--R        |- 1   0    0    0    0    0    0    0    0 |
+--R        |                                           |
+--R        | 1    1    1    0    0    0    0    0    0 |
+--R        |                                           |
+--R        | 0    1    0    0    0    0    0    0   - 1|
+--R        |                                           |
+--R   (4)  | 0    0    0    0    0    0    1    0    0 |
+--R        |                                           |
+--R        | 0    0    0    0    1    0    0    0    0 |
+--R        |                                           |
+--R        | 1    0    0    0    0    0   - 1  - 1   0 |
+--R        |                                           |
+--R        |- 1  - 1  - 1  - 1  - 1  - 1   0    0    0 |
+--R        |                                           |
+--R        + 0    0    0    1    0    0    0    0    0 +
+--R                                                         Type: Matrix Integer
 --E 17
 
---S 18 of 67
-r2 := irrRepSymNat([4,2],[3,2,1,5,6,4])
---R 
---R   There are no library operations named irrRepSymNat 
---R      Use HyperDoc Browse or issue
---R                            )what op irrRepSymNat
---R      to learn if there is any operation containing " irrRepSymNat " in
---R      its name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      irrRepSymNat with argument type(s) 
---R                            List PositiveInteger
---R                            List PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--S 18 of 68
+r2 := irreducibleRepresentation([4,2],[3,2,1,5,6,4])
+--R 
+--R
+--R        + 0    0   - 1   0    0    0    0   - 1   0 +
+--R        |                                           |
+--R        | 1    0    1    0   - 1   0   - 1   0    0 |
+--R        |                                           |
+--R        | 0    0    0    0    1    0    0    0    0 |
+--R        |                                           |
+--R        | 0    0    0    0    0    0    0    1    0 |
+--R        |                                           |
+--R   (5)  |- 1   0    0   - 1   0    0    0    0    0 |
+--R        |                                           |
+--R        | 0    0    0    0    0    0    1    0    0 |
+--R        |                                           |
+--R        | 0    0   - 1   0    0   - 1   0   - 1  - 1|
+--R        |                                           |
+--R        | 0    0    0    0    0    0    0    0    1 |
+--R        |                                           |
+--R        + 0   - 1   0    0   - 1   0   - 1   0    0 +
+--R                                                         Type: Matrix Integer
 --E 18
 
---S 19 of 67
-r3 := irrRepSymNat([4,2],[4,2,1,3,6,5])
---R 
---R   There are no library operations named irrRepSymNat 
---R      Use HyperDoc Browse or issue
---R                            )what op irrRepSymNat
---R      to learn if there is any operation containing " irrRepSymNat " in
---R      its name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      irrRepSymNat with argument type(s) 
---R                            List PositiveInteger
---R                            List PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--S 19 of 68
+r3 := irreducibleRepresentation([4,2],[4,2,1,3,6,5])
+--R 
+--R
+--R        +0   0    0   0   1    0    1    0    1 +
+--R        |                                       |
+--R        |0   0    0   0   0    1    0    1    0 |
+--R        |                                       |
+--R        |0   0    0   1   0    0    0    0    0 |
+--R        |                                       |
+--R        |0  - 1   0   0  - 1   0   - 1   0    0 |
+--R        |                                       |
+--R   (6)  |0   0   - 1  0   0   - 1   0   - 1  - 1|
+--R        |                                       |
+--R        |1   1    1   0   0    0    0    0    0 |
+--R        |                                       |
+--R        |0   0    0   0   0    0    0    0    1 |
+--R        |                                       |
+--R        |0   0    0   0   1    0    0    0    0 |
+--R        |                                       |
+--R        +0   0    0   0   0    1    0    0    0 +
+--R                                                         Type: Matrix Integer
 --E 19
 
---S 20 of 67
+--S 20 of 68
 (r3 = r1*r2) :: Boolean
 --R 
 --R
---R   (2)  false
+--R   (7)  false
 --R                                                                Type: Boolean
 --E 20
 
---S 21 of 67
-irrRepSymNat [4,4,1]
+--S 21 of 68
+irreducibleRepresentation [4,4,1]
 --R 
 --R
---R   (3)  irrRepSymNat
---R                    4,4,1
---R                                                                 Type: Symbol
+--R   (8)
+--R   [
+--R   [
+--R     [- 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, - 1, 0, 0, 0, 1, 0, - 1,
+--R      0, - 1, - 1, - 1, 0, 1, 1, 0, 0, 0, 0, - 1, 0, - 1, 1, - 1, - 1, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, - 1, 0, 0, 0, 1, 1, 0,
+--R      1, 1, 0, - 1, - 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, - 1, 0, - 1, 0, 1,
+--R      0, 0, 1, 1, 0, 0, - 1, 0, - 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, - 1, 0, - 1,
+--R      - 1, 0, 0, 0, 0, 1, 0, 0, - 1, 0, - 1, - 1, 0, 0, 0, - 1, 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, - 1,
+--R      - 1, - 1, 0, 0, 1, 0, 0, 0, 0, 0, - 1, - 1, - 1, 1, - 1, - 1, - 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 1, 1, 0, 0, 0,
+--R      0, - 1, 0, - 1, 1, - 1, - 1, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0, 1, 0,
+--R      0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, - 1, 0, - 1,
+--R      0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, - 1, 0,
+--R      - 1, - 1, 0, 0, 0, - 1, 1, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0,
+--R      0, - 1, - 1, - 1, 1, - 1, - 1, - 1, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, - 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 1, - 1, - 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0,
+--R      0, 0, 0, 0, - 1, 0, 0, 0, - 1, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0,
+--R      0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0,
+--R      0, 0, 0, 0, 0, - 1, 0, 0, 0, - 1, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
+--R      0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, - 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      1, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, - 1]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 1, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 1, - 1, - 1, - 1]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, - 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 1]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, - 1, 0, 0, 0, - 1, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, - 1, 0, 0, 0, - 1, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, - 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, - 1]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1]
+--R     ]
+--R     ,
+--R
+--R   [
+--R     [- 1, 0, - 1, - 1, 0, 0, 0, - 1, 0, - 1, 1, 0, 0, 1, - 1, 1, 1, - 1, 0, 0,
+--R      0, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 0, 1, 1, 0, 0, 0,
+--R      - 1, 0, - 1, 0, 0, - 1, - 1, 0, 0, 0, 0, - 1, - 1, - 1, 0, 0, - 1, 0, 0,
+--R      0, 0, 0, 0, - 1, - 1, 0, - 2, - 1, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 1,
+--R      1, 0]
+--R     ,
+--R
+--R     [1, 1, 1, 1, 0, 0, 0, 0, 0, 1, - 1, - 1, - 1, - 1, 0, 0, 0, 1, 1, 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, - 1, - 1, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0,
+--R      1, 1, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0]
+--R     ,
+--R
+--R     [1, 0, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0,
+--R      1, - 1, 1, 1, - 1, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0,
+--R      0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0]
+--R     ,
+--R
+--R     [- 1, - 1, 0, 0, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      1, - 1, - 1, 0, 0, 0, 1, 1, 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0,
+--R      0, 1, 1, 0, 0, 0, 0, - 1, - 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0,
+--R      - 1, - 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0]
+--R     ,
+--R
+--R     [0, 0, - 1, - 1, - 1, 0, 0, - 1, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      - 1, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0,
+--R      - 1, - 1, - 1, - 1, 0, - 1, - 1, 0, 0, 0, 0, - 1, - 1, - 1, - 1, 0, - 1,
+--R      - 1, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, - 1, - 1, 0, - 1, - 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, - 2, - 1, - 1, 1, 0, 1, 1, 0, 1,
+--R      1, 0, 1, 0, 0, - 1, - 1, 1, 1, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 1,
+--R      0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0]
+--R     ,
+--R
+--R     [- 1, - 1, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, - 1, - 1, - 1, - 1,
+--R      0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [- 1, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, - 1, 0, - 1, 0, 0, 0,
+--R      0, 0, - 1, 0, - 1, 0, 0, - 1, 0, - 1, 1, 1, - 1, 0, 0, 0, - 1, 0, 0, - 1,
+--R      0, 0, - 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0]
+--R     ,
+--R
+--R     [1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0, 0, 0, 1, 1, 0, 0, - 1, - 1,
+--R      0, 0, 0, 0, 1, 1, 1, - 1, - 1, - 1, - 1, 0, 0, 0, 1, - 1, 0, 0, 0, 0, 0,
+--R      0, 0, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, - 1, 0, 0, 1, 1, 1, 1,
+--R      0, 1, 1, 0, - 1, - 1, - 1, 1, 1, 1, 1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, - 1, 0, 1,
+--R      1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, - 1, - 1, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, - 1, - 1, - 1, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0, 0, 0,
+--R      0, 0, 0, 0, 0, - 1, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
+--R      1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0,
+--R      0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0,
+--R      0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1,
+--R      0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, - 1, 0, 0, 0, 0, 0,
+--R      0, 0, - 1, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1,
+--R      0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, - 1, 0, 0, 0, - 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, - 1, 0, 0, 0, 0,
+--R      0, 0, 0, - 1, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      - 1, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, - 1, 0, 0, 0, - 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, - 1, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      - 1, 0, 1, - 1, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, - 1, - 1, 0,
+--R      0, 0, 0, 0, 1, - 1, 0, 0, 0, - 1, - 1, - 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, - 1, 1, 1,
+--R      1, 1, 0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, - 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0,
+--R      0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0,
+--R      0, - 1, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0,
+--R      1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1,
+--R      0, 0, - 1, 0, 0, 0, - 1, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
+--R      1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0,
+--R      0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0,
+--R      0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1,
+--R      0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [- 1, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, - 1, 0, - 1,
+--R      0, 0, - 1, - 1, 0, 0, 0, 0, - 1, - 1, - 1, 0, 0, - 1, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, - 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, - 1, - 1, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0,
+--R      1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [- 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0, 0, 1, 1,
+--R      0, 0, 0, 0, - 1, - 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, - 1, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1,
+--R      - 1, - 1, 0, - 1, - 1, 0, 0, 0, 0, - 1, - 1, - 1, - 1, 0, - 1, - 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, - 1, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, - 1, - 1, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, - 1, - 1, - 1, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, - 1, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, - 1, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
+--R      1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0,
+--R      0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1,
+--R      0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0,
+--R      0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0,
+--R      1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0, 0, 0,
+--R      1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, - 1, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1,
+--R      - 1, - 1, - 1, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0,
+--R      0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1,
+--R      0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, - 1, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
+--R      0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, - 1, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1,
+--R      - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1,
+--R      - 1, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, - 1, 0, 0, - 1, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, - 1, 0, 0, - 1, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, - 1, 0, 0,
+--R      1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1,
+--R      - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, - 1, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0,
+--R      - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0,
+--R      - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, - 1, - 1, - 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, - 1, - 1, 0, 0, 0, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, - 1, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, - 1, 0, 0, - 1, 0, 0, 0, - 1, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, - 1, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, - 1, 0,
+--R      0, 0, 0, 0, 0, - 1, 0, 0, 0, - 1, 0, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1, 0,
+--R      0, - 1, 0, 0, 0, - 1, 0, 0, 0, - 1, 0, 0]
+--R     ,
+--R
+--R     [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+--R      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, - 1,
+--R      0, 0, - 1, 0, 0, 0, - 1, 0, 0, 0, - 1, 0]
+--R     ]
+--R     ]
+--R                                                    Type: List Matrix Integer
 --E 21
 
 )clear all
 
---S 22 of 67
+--S 22 of 68
 permutationRepresentation [2,3,1,4,6,5,11,10,7,8,9]
 --R 
 --R
@@ -333,7 +1312,7 @@ permutationRepresentation [2,3,1,4,6,5,11,10,7,8,9]
 --R                                                         Type: Matrix Integer
 --E 22
 
---S 23 of 67
+--S 23 of 68
 gm2 := createGenericMatrix 2
 --R 
 --R
@@ -345,7 +1324,7 @@ gm2 := createGenericMatrix 2
 --R                                              Type: Matrix Polynomial Integer
 --E 23
 
---S 24 of 67
+--S 24 of 68
 symmetricTensors (gm2,2)
 --R 
 --R
@@ -362,7 +1341,7 @@ symmetricTensors (gm2,2)
 --R                                              Type: Matrix Polynomial Integer
 --E 24
 
---S 25 of 67
+--S 25 of 68
 gm3 := createGenericMatrix 3
 --R 
 --R
@@ -377,7 +1356,7 @@ gm3 := createGenericMatrix 3
 --R                                              Type: Matrix Polynomial Integer
 --E 25
 
---S 26 of 67
+--S 26 of 68
 antisymmetricTensors (gm3,2)
 --R 
 --R
@@ -392,7 +1371,7 @@ antisymmetricTensors (gm3,2)
 --R                                              Type: Matrix Polynomial Integer
 --E 26
 
---S 27 of 67
+--S 27 of 68
 tensorProduct(gm2,gm2)
 --R 
 --R
@@ -412,7 +1391,7 @@ tensorProduct(gm2,gm2)
 --R                                              Type: Matrix Polynomial Integer
 --E 27
 
---S 28 of 67
+--S 28 of 68
 )sh REP1
 --R 
 --R RepresentationPackage1 R: Ring  is a package constructor
@@ -439,207 +1418,402 @@ tensorProduct(gm2,gm2)
 
 )clear all
 
---S 29 of 67
-r0 := irrRepSymNat [2,2,2,1,1]; r28 := meatAxe (r0::(LIST MATRIX PF 2))
---R 
+--S 29 of 68
+r0 := irreducibleRepresentation [2,2,2,1,1];
 --R 
---RDaly Bug
---R   Cannot convert from type Symbol to List Matrix PrimeField 2 for 
---R      value
---R   irrRepSymNat
---R               2,2,2,1,1
 --R
+--R                                                    Type: List Matrix Integer
 --E 29
 
---S 30 of 67
-areEquivalent? (r28.1, r28.2)
+--S 30 of 68
+r28 := meatAxe (r0::(LIST MATRIX PF 2))
 --R 
---R   There are no library operations named r28 
---R      Use HyperDoc Browse or issue
---R                                )what op r28
---R      to learn if there is any operation containing " r28 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named r28 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Fingerprint element in generated algebra is singular
+--R     A proper cyclic submodule is found.
+--R     Transition matrix computed
+--R     The inverse of the transition matrix computed
+--R     Now transform the matrices
+--R
+--R   (2)
+--R   [
+--R      +0  1  1  1  1  1  1  0  0  1  1  1  0  0+
+--R      |                                        |
+--R      |1  0  1  1  1  0  0  1  1  1  0  0  1  1|
+--R      |                                        |
+--R      |1  1  0  1  0  1  0  0  1  0  1  0  0  1|
+--R      |                                        |
+--R      |1  1  1  0  0  0  1  1  0  0  0  1  1  0|
+--R      |                                        |
+--R      |1  1  0  0  0  1  1  1  1  1  1  1  1  1|
+--R      |                                        |
+--R      |1  0  1  0  1  0  1  0  1  1  1  1  0  1|
+--R      |                                        |
+--R      |1  0  0  1  1  1  0  1  0  1  1  1  1  0|
+--R     [|                                        |,
+--R      |0  1  1  0  1  1  0  1  0  1  1  0  0  0|
+--R      |                                        |
+--R      |0  1  0  1  1  0  1  0  1  1  0  1  0  0|
+--R      |                                        |
+--R      |1  1  0  0  1  0  0  0  0  0  0  0  0  0|
+--R      |                                        |
+--R      |1  0  1  0  0  1  0  0  0  0  0  0  0  0|
+--R      |                                        |
+--R      |1  0  0  1  0  0  1  0  0  0  0  0  0  0|
+--R      |                                        |
+--R      |0  1  1  0  0  0  0  1  0  0  0  0  0  0|
+--R      |                                        |
+--R      +0  1  0  1  0  0  0  0  1  0  0  0  0  0+
+--R      +1  1  1  1  0  0  0  0  0  0  0  0  0  0+
+--R      |                                        |
+--R      |1  1  1  0  0  0  1  0  0  1  1  0  0  0|
+--R      |                                        |
+--R      |1  1  1  0  0  0  0  0  1  1  0  0  1  0|
+--R      |                                        |
+--R      |1  1  1  0  0  0  0  1  1  0  1  0  1  0|
+--R      |                                        |
+--R      |1  1  1  0  0  0  0  1  0  1  1  1  1  0|
+--R      |                                        |
+--R      |1  1  1  0  0  1  0  0  0  1  1  0  1  1|
+--R      |                                        |
+--R      |1  1  1  0  1  0  0  0  0  1  1  0  0  1|
+--R      |                                        |]
+--R      |1  1  0  0  0  0  0  0  0  0  1  1  1  1|
+--R      |                                        |
+--R      |1  0  1  0  0  0  0  0  0  1  0  1  0  1|
+--R      |                                        |
+--R      |0  0  0  1  0  0  1  0  0  1  1  1  1  0|
+--R      |                                        |
+--R      |0  0  0  1  0  0  0  0  1  1  1  0  1  1|
+--R      |                                        |
+--R      |0  0  0  1  0  0  0  1  1  1  1  0  0  1|
+--R      |                                        |
+--R      |0  0  0  0  0  0  1  0  1  0  1  1  1  1|
+--R      |                                        |
+--R      +0  0  0  0  0  0  1  1  1  1  0  1  0  1+
+--R     ,
+--R
+--R      +1  0  0  0  0  0  0  0  1  1  1  1  1  1+
+--R      |                                        |
+--R      |0  1  0  0  0  0  0  0  1  1  1  0  0  0|
+--R      |                                        |
+--R      |0  0  1  0  0  1  1  0  1  0  0  1  0  0|
+--R      |                                        |
+--R      |0  0  0  1  0  1  0  1  0  1  0  0  1  0|
+--R      |                                        |
+--R      |0  0  0  0  1  0  1  1  1  1  0  0  0  1|
+--R      |                                        |
+--R      |0  0  0  0  0  1  1  1  1  1  0  1  1  0|
+--R      |                                        |
+--R      |0  0  0  0  0  1  1  1  1  0  1  1  0  1|
+--R     [|                                        |,
+--R      |0  0  0  0  0  1  1  1  0  1  1  0  1  1|
+--R      |                                        |
+--R      |0  0  0  0  0  1  1  0  1  1  1  1  0  0|
+--R      |                                        |
+--R      |0  0  0  0  0  1  0  1  1  1  1  0  1  0|
+--R      |                                        |
+--R      |0  0  0  0  0  0  1  1  1  1  1  1  1  0|
+--R      |                                        |
+--R      |0  0  0  0  0  0  0  0  0  0  0  0  1  1|
+--R      |                                        |
+--R      |0  0  0  0  0  0  0  0  0  0  0  1  0  1|
+--R      |                                        |
+--R      +0  0  0  0  0  0  0  0  0  0  0  0  0  1+
+--R      +0  0  1  1  1  1  1  0  1  0  0  0  0  0+
+--R      |                                        |
+--R      |0  0  1  0  0  0  0  0  0  0  0  0  1  1|
+--R      |                                        |
+--R      |0  0  0  0  0  0  0  1  0  1  0  0  1  0|
+--R      |                                        |
+--R      |0  0  0  0  0  0  0  1  0  0  1  0  0  1|
+--R      |                                        |
+--R      |0  0  1  0  0  0  0  0  0  1  1  0  1  1|
+--R      |                                        |
+--R      |0  0  0  0  0  0  0  1  1  0  0  1  0  0|
+--R      |                                        |
+--R      |0  0  0  0  0  0  1  0  0  1  0  1  0  0|
+--R      |                                        |]
+--R      |1  1  0  0  0  1  0  0  0  0  1  1  0  0|
+--R      |                                        |
+--R      |0  0  1  1  0  0  1  0  1  0  0  0  1  0|
+--R      |                                        |
+--R      |1  0  1  0  1  1  0  0  1  0  0  0  0  1|
+--R      |                                        |
+--R      |1  0  1  1  1  0  0  0  1  0  0  0  1  1|
+--R      |                                        |
+--R      |0  0  1  1  0  0  1  1  1  1  0  1  1  0|
+--R      |                                        |
+--R      |0  1  1  0  1  1  0  1  1  0  1  1  0  1|
+--R      |                                        |
+--R      +0  1  1  1  1  0  0  0  1  1  1  1  1  1+
+--R     ]
+--R                                          Type: List List Matrix PrimeField 2
 --E 30
 
---S 31 of 67
-meatAxe r28.2
+--S 31 of 68
+areEquivalent? (r28.1, r28.2)
 --R 
---R   There are no library operations named r28 
---R      Use HyperDoc Browse or issue
---R                                )what op r28
---R      to learn if there is any operation containing " r28 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named r28 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Dimensions of kernels differ
+--R
+--R   Representations are not equivalent.
+--R
+--R   (3)  [0]
+--R                                                    Type: Matrix PrimeField 2
 --E 31
 
---S 32 of 67
-isAbsolutelyIrreducible? r28.2
+--S 32 of 68
+meatAxe r28.2
 --R 
---R   There are no library operations named r28 
---R      Use HyperDoc Browse or issue
---R                                )what op r28
---R      to learn if there is any operation containing " r28 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named r28 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Fingerprint element in generated algebra is non-singular
+--R   Fingerprint element in generated algebra is singular
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     We know that all the cyclic submodules generated by all
+--R       non-trivial element of the singular matrix under view are
+--R       not proper, hence Norton's irreducibility test can be done:
+--R     The generated cyclic submodule was not proper
+--R     Representation is irreducible, but we don't know
+--R       whether it is absolutely irreducible
+--R
+--R   (4)
+--R   [
+--R      +1  0  0  0  0  0  0  0  0  0  0  0  0  0+
+--R      |                                        |
+--R      |0  1  0  0  0  0  0  0  0  0  0  0  0  0|
+--R      |                                        |
+--R      |0  0  1  0  0  0  0  0  0  0  0  0  0  0|
+--R      |                                        |
+--R      |0  0  0  1  0  0  0  0  0  0  0  0  0  0|
+--R      |                                        |
+--R      |0  0  0  0  1  0  0  0  0  0  0  0  0  0|
+--R      |                                        |
+--R      |0  0  1  1  0  1  1  1  1  1  0  0  0  0|
+--R      |                                        |
+--R      |0  0  1  0  1  1  1  1  1  0  1  0  0  0|
+--R     [|                                        |,
+--R      |0  0  0  1  1  1  1  1  0  1  1  0  0  0|
+--R      |                                        |
+--R      |1  1  1  0  1  1  1  0  1  1  1  0  0  0|
+--R      |                                        |
+--R      |1  1  0  1  1  1  0  1  1  1  1  0  0  0|
+--R      |                                        |
+--R      |1  1  0  0  0  0  1  1  1  1  1  0  0  0|
+--R      |                                        |
+--R      |1  0  1  0  0  1  1  0  1  0  1  0  1  0|
+--R      |                                        |
+--R      |1  0  0  1  0  1  0  1  0  1  1  1  0  0|
+--R      |                                        |
+--R      +1  0  0  0  1  0  1  1  0  0  0  1  1  1+
+--R      +0  0  0  0  0  0  0  1  0  1  1  0  0  0+
+--R      |                                        |
+--R      |0  0  0  0  0  0  0  1  0  0  0  0  1  1|
+--R      |                                        |
+--R      |1  1  0  0  1  0  0  0  1  1  1  1  1  1|
+--R      |                                        |
+--R      |1  0  0  0  0  0  0  0  1  0  1  1  0  1|
+--R      |                                        |
+--R      |1  0  0  0  0  0  0  0  0  1  1  0  1  1|
+--R      |                                        |
+--R      |1  0  0  0  0  0  0  1  0  1  0  0  1  0|
+--R      |                                        |
+--R      |1  0  0  0  0  0  1  0  1  0  0  1  0  0|
+--R      |                                        |]
+--R      |0  0  1  1  0  1  0  0  0  0  0  1  1  0|
+--R      |                                        |
+--R      |1  0  0  0  0  1  0  0  1  1  1  1  1  1|
+--R      |                                        |
+--R      |0  0  1  0  1  0  1  0  0  0  0  1  0  1|
+--R      |                                        |
+--R      |0  0  0  1  1  0  0  1  0  0  0  0  1  1|
+--R      |                                        |
+--R      |0  0  0  0  0  1  1  1  0  0  0  1  1  1|
+--R      |                                        |
+--R      |0  1  1  0  1  0  0  0  1  0  1  1  0  1|
+--R      |                                        |
+--R      +0  1  0  1  1  0  0  0  0  1  1  0  1  1+
+--R     ]
+--R                                          Type: List List Matrix PrimeField 2
 --E 32
 
---S 33 of 67
-ma := meatAxe r28.1
+--S 33 of 68 random generation, FAILURE OK.
+isAbsolutelyIrreducible? r28.2
 --R 
---R   There are no library operations named r28 
---R      Use HyperDoc Browse or issue
---R                                )what op r28
---R      to learn if there is any operation containing " r28 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named r28 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra has
+--R     one-dimensional kernel
+--R     We know that all the cyclic submodules generated by all
+--R       non-trivial element of the singular matrix under view are
+--R       not proper, hence Norton's irreducibility test can be done:
+--R     The generated cyclic submodule was not proper
+--R     Representation is absolutely irreducible
+--R
+--R   (5)  true
+--R                                                                Type: Boolean
 --E 33
 
---S 34 of 67
-isAbsolutelyIrreducible? ma.1
+--S 34 of 68
+ma := meatAxe r28.1
 --R 
---R   There are no library operations named ma 
---R      Use HyperDoc Browse or issue
---R                                 )what op ma
---R      to learn if there is any operation containing " ma " in its name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named ma 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Fingerprint element in generated algebra is singular
+--R     The generated cyclic submodule was not proper
+--R     A proper cyclic submodule is found.
+--R     Transition matrix computed
+--R     The inverse of the transition matrix computed
+--R     Now transform the matrices
+--R
+--R   (6)
+--R     +0  0  0  0  1  0  1  1+ +1  1  1  1  1  1  0  0+
+--R     |                      | |                      |
+--R     |0  0  0  0  0  1  0  1| |1  0  0  1  1  0  1  0|
+--R     |                      | |                      |
+--R     |0  0  0  0  0  0  1  1| |0  0  1  1  0  0  1  0|
+--R     |                      | |                      |
+--R     |0  0  0  0  0  0  0  1| |1  1  0  1  1  1  1  1|
+--R   [[|                      |,|                      |],
+--R     |1  0  1  0  0  0  0  0| |1  1  1  1  0  0  1  0|
+--R     |                      | |                      |
+--R     |0  1  0  1  0  0  0  0| |1  0  0  1  1  1  1  1|
+--R     |                      | |                      |
+--R     |0  0  1  1  0  0  0  0| |0  1  1  0  1  0  1  1|
+--R     |                      | |                      |
+--R     +0  0  0  1  0  0  0  0+ +1  0  0  1  0  1  0  1+
+--R     +0  1  1  0  0  1+ +1  1  0  0  0  0+
+--R     |                | |                |
+--R     |1  0  1  0  0  1| |1  0  1  1  0  0|
+--R     |                | |                |
+--R     |1  1  0  0  0  1| |1  0  0  1  0  1|
+--R    [|                |,|                |]]
+--R     |0  0  0  1  0  0| |1  0  1  1  1  0|
+--R     |                | |                |
+--R     |0  0  0  0  1  0| |1  0  0  0  1  1|
+--R     |                | |                |
+--R     +1  1  1  0  0  0+ +0  1  1  1  0  1+
+--R                                          Type: List List Matrix PrimeField 2
 --E 34
 
---S 35 of 67
-isAbsolutelyIrreducible? ma.2
+--S 35 of 68
+isAbsolutelyIrreducible? ma.1
 --R 
---R   There are no library operations named ma 
---R      Use HyperDoc Browse or issue
---R                                 )what op ma
---R      to learn if there is any operation containing " ma " in its name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named ma 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra has
+--R     one-dimensional kernel
+--R     We know that all the cyclic submodules generated by all
+--R       non-trivial element of the singular matrix under view are
+--R       not proper, hence Norton's irreducibility test can be done:
+--R     The generated cyclic submodule was not proper
+--R     Representation is absolutely irreducible
+--R
+--R   (7)  true
+--R                                                                Type: Boolean
 --E 35
 
+--S 36 of 68
+isAbsolutelyIrreducible? ma.2
+--R 
+--R   Random element in generated algebra has
+--R     one-dimensional kernel
+--R     We know that all the cyclic submodules generated by all
+--R       non-trivial element of the singular matrix under view are
+--R       not proper, hence Norton's irreducibility test can be done:
+--R     The generated cyclic submodule was not proper
+--R     Representation is absolutely irreducible
+--R
+--R   (8)  true
+--R                                                                Type: Boolean
+--E 36
+
 )clear all
 
---S 36 of 67
+--S 37 of 68
 px : PERM PF 29 := cycles [[1,3,5],[7,11,9]]
 --R 
 --R
 --R   (1)  (1 3 5)(7 11 9)
 --R                                              Type: Permutation PrimeField 29
---E 36
+--E 37
 
---S 37 of 67
+--S 38 of 68
 py : PERM PF 29 := cycles [[3,5,7,9]]
 --R 
 --R
 --R   (2)  (3 5 7 9)
 --R                                              Type: Permutation PrimeField 29
---E 37
+--E 38
 
---S 38 of 67
+--S 39 of 68
 pz : PERM PF 29 := cycle [1,3,11]
 --R 
 --R
 --R   (3)  (1 3 11)
 --R                                              Type: Permutation PrimeField 29
---E 38
+--E 39
 
---S 39 of 67
+--S 40 of 68
 px * pz
 --R 
 --R
 --R   (4)  (1 5)(3 9 7 11)
 --R                                              Type: Permutation PrimeField 29
---E 39
+--E 40
 
---S 40 of 67
+--S 41 of 68
 py ** 3
 --R 
 --R
 --R   (5)  (3 9 7 5)
 --R                                              Type: Permutation PrimeField 29
---E 40
+--E 41
 
---S 41 of 67
+--S 42 of 68
 inv px
 --R 
 --R
 --R   (6)  (1 5 3)(7 9 11)
 --R                                              Type: Permutation PrimeField 29
---E 41
+--E 42
 
---S 42 of 67
+--S 43 of 68
 order px
 --R 
 --R
 --R   (7)  3
 --R                                                        Type: PositiveInteger
---E 42
+--E 43
 
---S 43 of 67
+--S 44 of 68
 movedPoints py
 --R 
 --R
 --R   (8)  {3,5,7,9}
 --R                                                      Type: Set PrimeField 29
---E 43
+--E 44
 
---S 44 of 67
+--S 45 of 68
 orbit ( pz , 3 )
 --R 
 --R
 --R   (9)  {3,11,1}
 --R                                                      Type: Set PrimeField 29
---E 44
+--E 45
 
---S 45 of 67
+--S 46 of 68
 eval ( py , 7 )
 --R 
 --R
 --R   (10)  9
 --R                                                          Type: PrimeField 29
---E 45
+--E 46
 
---S 46 of 67
+--S 47 of 68
 )sh PERM
 --R 
 --R Permutation S: SetCategory  is a domain constructor
@@ -679,19 +1853,19 @@ eval ( py , 7 )
 --R min : (%,%) -> % if S has FINITE or S has ORDSET
 --R numberOfCycles : % -> NonNegativeInteger
 --R
---E
+--E 47
 
 )clear all
 
---S 47 of 67
+--S 48 of 68
 genA6 : List PERM INT := [cycle [1,2,3],cycle [2,3,4,5,6]]
 --R 
 --R
 --R   (1)  [(1 2 3),(2 3 4 5 6)]
 --R                                               Type: List Permutation Integer
---E 47
+--E 48
 
---S 48 of 67
+--S 49 of 68
 pRA6 := permutationRepresentation (genA6,6)
 --R 
 --R
@@ -707,9 +1881,9 @@ pRA6 := permutationRepresentation (genA6,6)
 --R         |                | |                |
 --R         +0  0  0  0  0  1+ +0  0  0  0  1  0+
 --R                                                    Type: List Matrix Integer
---E 48
+--E 49
 
---S 49 of 67
+--S 50 of 68
 sp0 := meatAxe (pRA6::(List Matrix PF 2))
 --R 
 --R   Fingerprint element in generated algebra is singular
@@ -728,9 +1902,9 @@ sp0 := meatAxe (pRA6::(List Matrix PF 2))
 --R          |             | |             |
 --R          +0  0  0  0  1+ +0  0  0  1  0+
 --R                                          Type: List List Matrix PrimeField 2
---E 49
+--E 50
 
---S 50 of 67
+--S 51 of 68
 sp1 := meatAxe sp0.1
 --R 
 --R   Fingerprint element in generated algebra is singular
@@ -754,9 +1928,9 @@ sp1 := meatAxe sp0.1
 --R                    |          | |          |
 --R                    +0  0  0  1+ +1  1  1  1+
 --R                                          Type: List List Matrix PrimeField 2
---E 50
+--E 51
 
---S 51 of 67 random generation, failure ok.
+--S 52 of 68 random generation, FAILURE OK.
 isAbsolutelyIrreducible? sp1.2
 --R 
 --R   Random element in generated algebra has
@@ -769,260 +1943,600 @@ isAbsolutelyIrreducible? sp1.2
 --R
 --I   (5)  true
 --R                                                                Type: Boolean
---E 51
-
---S 52 of 67
-d2211 := irrRepSymNat ([2,2,1,1],genA6)
---R 
---R   There are no library operations named irrRepSymNat 
---R      Use HyperDoc Browse or issue
---R                            )what op irrRepSymNat
---R      to learn if there is any operation containing " irrRepSymNat " in
---R      its name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      irrRepSymNat with argument type(s) 
---R                            List PositiveInteger
---R                          List Permutation Integer
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
 --E 52
 
---S 53 of 67
-d2211m2 := (d2211::(List Matrix PF 2)); sp2 := meatAxe d2211m2
+--S 53 of 68
+d2211 := irreducibleRepresentation ([2,2,1,1],genA6)
 --R 
---R 
---RDaly Bug
---R   Cannot convert from type Variable d2211 to List Matrix PrimeField 2 
---R      for value
---R   d2211
 --R
+--R   (6)
+--R    +1  0  0  - 1   1    0    0    0    0 + + 0    0   1   0   0  0   1   0  0+
+--R    |                                     | |                                 |
+--R    |0  1  0   1    0    1    0    0    0 | | 0    0   0   0   1  0  - 1  0  0|
+--R    |                                     | |                                 |
+--R    |0  0  1   0    1   - 1   0    0    0 | | 0    0   0   0   0  1   1   0  0|
+--R    |                                     | |                                 |
+--R    |0  0  0  - 1   0    0   - 1   0    0 | | 0    0   0   0   0  0   1   1  0|
+--R    |                                     | |                                 |
+--R   [|0  0  0   0   - 1   0    0   - 1   0 |,| 0    0   0   0   0  0  - 1  0  1|]
+--R    |                                     | |                                 |
+--R    |0  0  0   0    0   - 1   0    0   - 1| | 0    0   0   0   0  0   1   0  0|
+--R    |                                     | |                                 |
+--R    |0  0  0   1    0    0    0    0    0 | |- 1   0   0   0   0  0  - 1  0  0|
+--R    |                                     | |                                 |
+--R    |0  0  0   0    1    0    0    0    0 | | 0   - 1  0   0   0  0   1   0  0|
+--R    |                                     | |                                 |
+--R    +0  0  0   0    0    1    0    0    0 + + 0    0   0  - 1  0  0  - 1  0  0+
+--R                                                    Type: List Matrix Integer
 --E 53
 
---S 54 of 67
-isAbsolutelyIrreducible? sp2.1
+--S 54 of 68
+d2211m2 := (d2211::(List Matrix PF 2)); sp2 := meatAxe d2211m2
 --R 
---R   There are no library operations named sp2 
---R      Use HyperDoc Browse or issue
---R                                )what op sp2
---R      to learn if there is any operation containing " sp2 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named sp2 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Fingerprint element in generated algebra is singular
+--R     A proper cyclic submodule is found.
+--R     Transition matrix computed
+--R     The inverse of the transition matrix computed
+--R     Now transform the matrices
+--R
+--R                                      +1  0  0  0  0+ +1  1  1  0  0+
+--R          +1  0  1  1+ +0  0  1  0+   |             | |             |
+--R          |          | |          |   |0  1  1  1  1| |0  0  1  1  1|
+--R          |0  1  0  1| |1  1  1  1|   |             | |             |
+--R   (7)  [[|          |,|          |],[|0  1  1  0  0|,|1  0  0  1  0|]]
+--R          |1  1  0  0| |1  0  1  1|   |             | |             |
+--R          |          | |          |   |0  1  0  1  0| |0  0  1  0  1|
+--R          +0  1  0  0+ +0  1  0  1+   |             | |             |
+--R                                      +0  1  1  1  0+ +1  0  0  1  1+
+--R                                          Type: List List Matrix PrimeField 2
 --E 54
 
---S 55 of 67
-areEquivalent? (sp2.1, sp1.2)
+--S 55 of 68 random generation, FAILURE OK.
+isAbsolutelyIrreducible? sp2.1
 --R 
---R   There are no library operations named sp2 
---R      Use HyperDoc Browse or issue
---R                                )what op sp2
---R      to learn if there is any operation containing " sp2 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named sp2 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Random element in generated algebra has
+--R     one-dimensional kernel
+--R     We know that all the cyclic submodules generated by all
+--R       non-trivial element of the singular matrix under view are
+--R       not proper, hence Norton's irreducibility test can be done:
+--R     The generated cyclic submodule was not proper
+--R     Representation is absolutely irreducible
+--R
+--R   (8)  true
+--R                                                                Type: Boolean
 --E 55
 
---S 56 of 67
-dA6d16 := tensorProduct(sp2.1,sp1.2); meatAxe dA6d16
+--S 56 of 68 random generation, FAILURE OK.
+areEquivalent? (sp2.1, sp1.2)
 --R 
---R   There are no library operations named sp2 
---R      Use HyperDoc Browse or issue
---R                                )what op sp2
---R      to learn if there is any operation containing " sp2 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named sp2 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Dimensions of kernels differ
+--R
+--R   Representations are not equivalent.
+--R
+--R   (9)  [0]
+--R                                                    Type: Matrix PrimeField 2
 --E 56
 
---S 57 of 67
-isAbsolutelyIrreducible? dA6d16
+--S 57 of 68
+dA6d16 := tensorProduct(sp2.1,sp1.2); meatAxe dA6d16
 --R 
---R   There are 1 exposed and 0 unexposed library operations named 
---R      isAbsolutelyIrreducible? having 1 argument(s) but none was 
---R      determined to be applicable. Use HyperDoc Browse, or issue
---R                    )display op isAbsolutelyIrreducible?
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      isAbsolutelyIrreducible? with argument type(s) 
---R                               Variable dA6d16
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Fingerprint element in generated algebra is non-singular
+--R   Fingerprint element in generated algebra is singular
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R   Fingerprint element in generated algebra is non-singular
+--R   Fingerprint element in generated algebra is singular
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R   Fingerprint element in generated algebra is singular
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     We know that all the cyclic submodules generated by all
+--R       non-trivial element of the singular matrix under view are
+--R       not proper, hence Norton's irreducibility test can be done:
+--R     The generated cyclic submodule was not proper
+--R     Representation is irreducible, but we don't know
+--R       whether it is absolutely irreducible
+--R
+--R   (10)
+--R   [
+--R      +0  0  1  0  0  0  0  0  0  0  1  0  0  0  0  0+
+--R      |                                              |
+--R      |1  0  0  0  0  0  0  0  1  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      |0  1  0  0  0  0  0  0  0  1  0  0  0  0  0  0|
+--R      |                                              |
+--R      |0  0  0  1  0  0  0  0  0  0  0  1  0  0  0  0|
+--R      |                                              |
+--R      |0  0  0  0  0  0  1  0  0  0  1  0  0  0  1  0|
+--R      |                                              |
+--R      |0  0  0  0  1  0  0  0  1  0  0  0  1  0  0  0|
+--R      |                                              |
+--R      |0  0  0  0  0  1  0  0  0  1  0  0  0  1  0  0|
+--R      |                                              |
+--R      |0  0  0  0  0  0  0  1  0  0  0  1  0  0  0  1|
+--R     [|                                              |,
+--R      |0  0  1  0  0  0  0  0  0  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      |1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      |0  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      |0  0  0  1  0  0  0  0  0  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      |0  0  1  0  0  0  1  0  0  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      |1  0  0  0  1  0  0  0  0  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      |0  1  0  0  0  1  0  0  0  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      +0  0  0  1  0  0  0  1  0  0  0  0  0  0  0  0+
+--R      +0  0  0  0  0  1  1  1  0  1  1  1  0  0  0  0+
+--R      |                                              |
+--R      |0  0  0  0  1  1  1  1  1  1  1  1  0  0  0  0|
+--R      |                                              |
+--R      |0  0  0  0  1  0  1  1  1  0  1  1  0  0  0  0|
+--R      |                                              |
+--R      |0  0  0  0  1  1  0  1  1  1  0  1  0  0  0  0|
+--R      |                                              |
+--R      |0  0  0  0  0  1  1  1  0  0  0  0  0  1  1  1|
+--R      |                                              |
+--R      |0  0  0  0  1  1  1  1  0  0  0  0  1  1  1  1|
+--R      |                                              |
+--R      |0  0  0  0  1  0  1  1  0  0  0  0  1  0  1  1|
+--R      |                                              |
+--R      |0  0  0  0  1  1  0  1  0  0  0  0  1  1  0  1|
+--R      |                                              |]
+--R      |0  1  1  1  0  1  1  1  0  1  1  1  0  0  0  0|
+--R      |                                              |
+--R      |1  1  1  1  1  1  1  1  1  1  1  1  0  0  0  0|
+--R      |                                              |
+--R      |1  0  1  1  1  0  1  1  1  0  1  1  0  0  0  0|
+--R      |                                              |
+--R      |1  1  0  1  1  1  0  1  1  1  0  1  0  0  0  0|
+--R      |                                              |
+--R      |0  0  0  0  0  1  1  1  0  1  1  1  0  1  1  1|
+--R      |                                              |
+--R      |0  0  0  0  1  1  1  1  1  1  1  1  1  1  1  1|
+--R      |                                              |
+--R      |0  0  0  0  1  0  1  1  1  0  1  1  1  0  1  1|
+--R      |                                              |
+--R      +0  0  0  0  1  1  0  1  1  1  0  1  1  1  0  1+
+--R     ]
+--R                                          Type: List List Matrix PrimeField 2
 --E 57
 
---S 58 of 67
-sp3 := meatAxe (dA6d16 :: (List Matrix FF(2,2)))
---R 
+--S 58 of 68
+isAbsolutelyIrreducible? dA6d16
 --R 
---RDaly Bug
---R   Cannot convert from type Variable dA6d16 to List Matrix FiniteField(
---R      2,2) for value
---R   dA6d16
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   We have not found a one-dimensional kernel so far,
+--R     as we do a random search you could try again
 --R
+--R   (11)  false
+--R                                                                Type: Boolean
 --E 58
 
---S 59 of 67
-isAbsolutelyIrreducible? sp3.1
+--S 59 of 68
+sp3 := meatAxe (dA6d16 :: (List Matrix FF(2,2)))
 --R 
---R   There are no library operations named sp3 
---R      Use HyperDoc Browse or issue
---R                                )what op sp3
---R      to learn if there is any operation containing " sp3 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named sp3 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Fingerprint element in generated algebra is non-singular
+--R   Fingerprint element in generated algebra is singular
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R   Fingerprint element in generated algebra is non-singular
+--R   Fingerprint element in generated algebra is singular
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R   Fingerprint element in generated algebra is singular
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     A proper cyclic submodule is found.
+--R     Transition matrix computed
+--R     The inverse of the transition matrix computed
+--R     Now transform the matrices
+--R
+--R   (12)
+--R   [
+--R      +%A + 1  %A + 1    0       %A      1       %A      %A    %A + 1+
+--R      |                                                              |
+--R      |  %A      0     %A + 1  %A + 1    1     %A + 1  %A + 1    %A  |
+--R      |                                                              |
+--R      |  %A    %A + 1    %A      0       1       %A    %A + 1    0   |
+--R      |                                                              |
+--R      |  0       %A    %A + 1    %A      0       1       1       0   |
+--R     [|                                                              |,
+--R      |  %A      %A    %A + 1    1     %A + 1    %A      0       %A  |
+--R      |                                                              |
+--R      |%A + 1    %A    %A + 1    1       %A      0       %A    %A + 1|
+--R      |                                                              |
+--R      |  1       1       1       0     %A + 1  %A + 1    %A      0   |
+--R      |                                                              |
+--R      +  0     %A + 1    %A      0       0       %A    %A + 1  %A + 1+
+--R      +  0     %A + 1  %A + 1    %A    1     1       0       %A  +
+--R      |                                                          |
+--R      |%A + 1  %A + 1    1       0     1   %A + 1    1     %A + 1|
+--R      |                                                          |
+--R      |  %A      0       1       1     %A  %A + 1  %A + 1    0   |
+--R      |                                                          |
+--R      |  %A      1       0       %A    %A    0       1       %A  |
+--R      |                                                          |]
+--R      |  1       1       0     %A + 1  0     1       1       0   |
+--R      |                                                          |
+--R      |  1       %A      1       0     1     0       0       %A  |
+--R      |                                                          |
+--R      |%A + 1    0       1       1     0     %A    %A + 1    1   |
+--R      |                                                          |
+--R      +%A + 1    %A      %A    %A + 1  0   %A + 1    %A      0   +
+--R     ,
+--R
+--R      +%A + 1    %A      %A      0       %A      1     %A + 1    0   +
+--R      |                                                              |
+--R      |%A + 1    1       0     %A + 1    1     %A + 1    1       %A  |
+--R      |                                                              |
+--R      |  1       1       %A      %A      1       %A      1     %A + 1|
+--R      |                                                              |
+--R      |  1       0       1     %A + 1  %A + 1    0       %A      1   |
+--R     [|                                                              |,
+--R      |  1       1       1       0     %A + 1  %A + 1    %A      0   |
+--R      |                                                              |
+--R      |%A + 1    %A      %A      1     %A + 1    1       1     %A + 1|
+--R      |                                                              |
+--R      |%A + 1  %A + 1    %A      1       0       1       %A      %A  |
+--R      |                                                              |
+--R      +  %A      0     %A + 1    0       1       0       1       %A  +
+--R      +  1     1     %A    %A + 1    0       %A    %A + 1  %A + 1+
+--R      |                                                          |
+--R      |%A + 1  0     0       1     %A + 1    1       1     %A + 1|
+--R      |                                                          |
+--R      |  %A    0     1       0     %A + 1    0     %A + 1    1   |
+--R      |                                                          |
+--R      |  1     1   %A + 1    %A      %A      %A      1       0   |
+--R      |                                                          |]
+--R      |  1     %A    0       1       1       %A      1       0   |
+--R      |                                                          |
+--R      |  1     0     1     %A + 1    0     %A + 1    1     %A + 1|
+--R      |                                                          |
+--R      |  0     1   %A + 1    1       1     %A + 1  %A + 1    1   |
+--R      |                                                          |
+--R      +  %A    %A  %A + 1  %A + 1    %A      %A      0       1   +
+--R     ]
+--R                                      Type: List List Matrix FiniteField(2,2)
 --E 59
 
---S 60 of 67
-isAbsolutelyIrreducible? sp3.2
+--S 60 of 68 random generation, FAILURE OK.
+isAbsolutelyIrreducible? sp3.1
 --R 
---R   There are no library operations named sp3 
---R      Use HyperDoc Browse or issue
---R                                )what op sp3
---R      to learn if there is any operation containing " sp3 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named sp3 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra has
+--R     one-dimensional kernel
+--R     We know that all the cyclic submodules generated by all
+--R       non-trivial element of the singular matrix under view are
+--R       not proper, hence Norton's irreducibility test can be done:
+--R     The generated cyclic submodule was not proper
+--R     Representation is absolutely irreducible
+--R
+--R   (13)  true
+--R                                                                Type: Boolean
 --E 60
 
---S 61 of 67
-areEquivalent? (sp3.1,sp3.2)
+--S 61 of 68 random generation, FAILURE OK.
+isAbsolutelyIrreducible? sp3.2
 --R 
---R   There are no library operations named sp3 
---R      Use HyperDoc Browse or issue
---R                                )what op sp3
---R      to learn if there is any operation containing " sp3 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named sp3 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra has
+--R     one-dimensional kernel
+--R     We know that all the cyclic submodules generated by all
+--R       non-trivial element of the singular matrix under view are
+--R       not proper, hence Norton's irreducibility test can be done:
+--R     The generated cyclic submodule was not proper
+--R     Representation is absolutely irreducible
+--R
+--R   (14)  true
+--R                                                                Type: Boolean
 --E 61
 
---S 62 of 67
+--S 62 of 68 random generation, FAILURE OK.
+areEquivalent? (sp3.1,sp3.2)
+--R 
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra has
+--R     one-dimensional kernel
+--R     There is no isomorphism, as the only possible one
+--R       fails to do the necessary base change
+--R
+--R   Representations are not equivalent.
+--R
+--R   (15)  [0]
+--R                                                Type: Matrix FiniteField(2,2)
+--E 62
+
+--S 63 of 68
 sp0.2
 --R 
 --R
---R   (6)  [[1],[1]]
+--R   (16)  [[1],[1]]
 --R                                               Type: List Matrix PrimeField 2
---E 62
+--E 63
 
---S 63 of 67
+--S 64 of 68
 sp1.2
 --R 
 --R
---R         +0  1  0  0+ +0  1  1  1+
---R         |          | |          |
---R         |0  0  1  0| |1  1  0  1|
---R   (7)  [|          |,|          |]
---R         |1  0  0  0| |1  1  1  0|
---R         |          | |          |
---R         +0  0  0  1+ +1  1  1  1+
+--R          +0  1  0  0+ +0  1  1  1+
+--R          |          | |          |
+--R          |0  0  1  0| |1  1  0  1|
+--R   (17)  [|          |,|          |]
+--R          |1  0  0  0| |1  1  1  0|
+--R          |          | |          |
+--R          +0  0  0  1+ +1  1  1  1+
 --R                                               Type: List Matrix PrimeField 2
---E 63
+--E 64
 
---S 64 of 67
+--S 65 of 68
 sp2.1
 --R 
---R   There are no library operations named sp2 
---R      Use HyperDoc Browse or issue
---R                                )what op sp2
---R      to learn if there is any operation containing " sp2 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named sp2 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
---E 64
+--R
+--R          +1  0  1  1+ +0  0  1  0+
+--R          |          | |          |
+--R          |0  1  0  1| |1  1  1  1|
+--R   (18)  [|          |,|          |]
+--R          |1  1  0  0| |1  0  1  1|
+--R          |          | |          |
+--R          +0  1  0  0+ +0  1  0  1+
+--R                                               Type: List Matrix PrimeField 2
+--E 65
 
---S 65 of 67
+--S 66 of 68
 sp3.1
 --R 
---R   There are no library operations named sp3 
---R      Use HyperDoc Browse or issue
---R                                )what op sp3
---R      to learn if there is any operation containing " sp3 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named sp3 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
---E 65
+--R
+--R   (19)
+--R    +%A + 1  %A + 1    0       %A      1       %A      %A    %A + 1+
+--R    |                                                              |
+--R    |  %A      0     %A + 1  %A + 1    1     %A + 1  %A + 1    %A  |
+--R    |                                                              |
+--R    |  %A    %A + 1    %A      0       1       %A    %A + 1    0   |
+--R    |                                                              |
+--R    |  0       %A    %A + 1    %A      0       1       1       0   |
+--R   [|                                                              |,
+--R    |  %A      %A    %A + 1    1     %A + 1    %A      0       %A  |
+--R    |                                                              |
+--R    |%A + 1    %A    %A + 1    1       %A      0       %A    %A + 1|
+--R    |                                                              |
+--R    |  1       1       1       0     %A + 1  %A + 1    %A      0   |
+--R    |                                                              |
+--R    +  0     %A + 1    %A      0       0       %A    %A + 1  %A + 1+
+--R    +  0     %A + 1  %A + 1    %A    1     1       0       %A  +
+--R    |                                                          |
+--R    |%A + 1  %A + 1    1       0     1   %A + 1    1     %A + 1|
+--R    |                                                          |
+--R    |  %A      0       1       1     %A  %A + 1  %A + 1    0   |
+--R    |                                                          |
+--R    |  %A      1       0       %A    %A    0       1       %A  |
+--R    |                                                          |]
+--R    |  1       1       0     %A + 1  0     1       1       0   |
+--R    |                                                          |
+--R    |  1       %A      1       0     1     0       0       %A  |
+--R    |                                                          |
+--R    |%A + 1    0       1       1     0     %A    %A + 1    1   |
+--R    |                                                          |
+--R    +%A + 1    %A      %A    %A + 1  0   %A + 1    %A      0   +
+--R                                           Type: List Matrix FiniteField(2,2)
+--E 66
 
---S 66 of 67
+--S 67 of 68
 sp3.2
 --R 
---R   There are no library operations named sp3 
---R      Use HyperDoc Browse or issue
---R                                )what op sp3
---R      to learn if there is any operation containing " sp3 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named sp3 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
---E 66
+--R
+--R   (20)
+--R    +%A + 1    %A      %A      0       %A      1     %A + 1    0   +
+--R    |                                                              |
+--R    |%A + 1    1       0     %A + 1    1     %A + 1    1       %A  |
+--R    |                                                              |
+--R    |  1       1       %A      %A      1       %A      1     %A + 1|
+--R    |                                                              |
+--R    |  1       0       1     %A + 1  %A + 1    0       %A      1   |
+--R   [|                                                              |,
+--R    |  1       1       1       0     %A + 1  %A + 1    %A      0   |
+--R    |                                                              |
+--R    |%A + 1    %A      %A      1     %A + 1    1       1     %A + 1|
+--R    |                                                              |
+--R    |%A + 1  %A + 1    %A      1       0       1       %A      %A  |
+--R    |                                                              |
+--R    +  %A      0     %A + 1    0       1       0       1       %A  +
+--R    +  1     1     %A    %A + 1    0       %A    %A + 1  %A + 1+
+--R    |                                                          |
+--R    |%A + 1  0     0       1     %A + 1    1       1     %A + 1|
+--R    |                                                          |
+--R    |  %A    0     1       0     %A + 1    0     %A + 1    1   |
+--R    |                                                          |
+--R    |  1     1   %A + 1    %A      %A      %A      1       0   |
+--R    |                                                          |]
+--R    |  1     %A    0       1       1       %A      1       0   |
+--R    |                                                          |
+--R    |  1     0     1     %A + 1    0     %A + 1    1     %A + 1|
+--R    |                                                          |
+--R    |  0     1   %A + 1    1       1     %A + 1  %A + 1    1   |
+--R    |                                                          |
+--R    +  %A    %A  %A + 1  %A + 1    %A      %A      0       1   +
+--R                                           Type: List Matrix FiniteField(2,2)
+--E 67
 
---S 67 of 67
+--S 68 of 68
 dA6d16
 --R 
 --R
---R   (8)  dA6d16
---R                                                        Type: Variable dA6d16
---E 67
+--R   (21)
+--R    +0  1  0  0  0  0  0  0  0  1  0  0  0  1  0  0+
+--R    |                                              |
+--R    |0  0  1  0  0  0  0  0  0  0  1  0  0  0  1  0|
+--R    |                                              |
+--R    |1  0  0  0  0  0  0  0  1  0  0  0  1  0  0  0|
+--R    |                                              |
+--R    |0  0  0  1  0  0  0  0  0  0  0  1  0  0  0  1|
+--R    |                                              |
+--R    |0  0  0  0  0  1  0  0  0  0  0  0  0  1  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  1  0  0  0  0  0  0  0  1  0|
+--R    |                                              |
+--R    |0  0  0  0  1  0  0  0  0  0  0  0  1  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  1  0  0  0  0  0  0  0  1|
+--R   [|                                              |,
+--R    |0  1  0  0  0  1  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  1  0  0  0  1  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |1  0  0  0  1  0  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  1  0  0  0  1  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  1  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  1  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  1  0  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    +0  0  0  0  0  0  0  1  0  0  0  0  0  0  0  0+
+--R    +0  0  0  0  0  0  0  0  0  1  1  1  0  0  0  0+
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  1  1  0  1  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  1  1  1  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  1  1  1  1  0  0  0  0|
+--R    |                                              |
+--R    |0  1  1  1  0  1  1  1  0  1  1  1  0  1  1  1|
+--R    |                                              |
+--R    |1  1  0  1  1  1  0  1  1  1  0  1  1  1  0  1|
+--R    |                                              |
+--R    |1  1  1  0  1  1  1  0  1  1  1  0  1  1  1  0|
+--R    |                                              |
+--R    |1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1|
+--R    |                                              |]
+--R    |0  1  1  1  0  0  0  0  0  1  1  1  0  1  1  1|
+--R    |                                              |
+--R    |1  1  0  1  0  0  0  0  1  1  0  1  1  1  0  1|
+--R    |                                              |
+--R    |1  1  1  0  0  0  0  0  1  1  1  0  1  1  1  0|
+--R    |                                              |
+--R    |1  1  1  1  0  0  0  0  1  1  1  1  1  1  1  1|
+--R    |                                              |
+--R    |0  0  0  0  0  1  1  1  0  0  0  0  0  1  1  1|
+--R    |                                              |
+--R    |0  0  0  0  1  1  0  1  0  0  0  0  1  1  0  1|
+--R    |                                              |
+--R    |0  0  0  0  1  1  1  0  0  0  0  0  1  1  1  0|
+--R    |                                              |
+--R    +0  0  0  0  1  1  1  1  0  0  0  0  1  1  1  1+
+--R                                               Type: List Matrix PrimeField 2
+--E 68
 )spool 
 )lisp (bye)
  
diff --git a/src/input/knot2.input.pamphlet b/src/input/knot2.input.pamphlet
index a793b46..7973989 100644
--- a/src/input/knot2.input.pamphlet
+++ b/src/input/knot2.input.pamphlet
@@ -63,57 +63,49 @@ l := lcm(p, q) quo p
 --E 4
 
 --S 5 of 8
-maxRange := (odd? l => l * %pi::SF; 2 * l * %pi::SF)  
+maxRange := (odd? l => l * %pi; 2 * l * %pi)  
 --R 
 --R
---R   (5)  15.707963267948966
---R                                                            Type: DoubleFloat
+--R   (5)  5%pi
+--R                                                                     Type: Pi
 --E 5
 
 --S 6 of 8
 theRange := 0..maxRange
 --R 
 --R
---R   (6)  0...15.707963267948966
---R                                                    Type: Segment DoubleFloat
+--R   (6)  0..(5%pi)
+--R                                                             Type: Segment Pi
 --E 6
 
 @
 Create the knot
-<<*>>=
---S 7 of 8
+\begin{verbatim}
 knot:TUBE := tubePlot(sin t * cos(PQ*t),cos t * cos(PQ*t),cos t * sin(PQ*t),
                       f, theRange, 0.1::SF, 6, "open" )
+\end{verbatim}
+<<*>>=
+--S 7 of 8
+v:=draw(curve(sin t * cos(PQ*t),cos t * cos(PQ*t),cos t * sin(PQ*t)), _
+        t=theRange, tubeRadius==0.1)
 --R 
---R 
---RDaly Bug
---R   Although TubePlot is the name of a constructor, a full type must be 
---R      specified in the context you have used it. Issue )show TubePlot 
---R      for more information.
+--I   Compiling function %B with type DoubleFloat -> DoubleFloat 
+--I   Compiling function %D with type DoubleFloat -> DoubleFloat 
+--I   Compiling function %F with type DoubleFloat -> DoubleFloat 
+--R   Transmitting data...
+--R
+--R   (7)  ThreeDimensionalViewport: "DCOS((3*t)/5)*DSIN(t)"
+--R                                               Type: ThreeDimensionalViewport
 --E 7
 
 @
-Make a viewport out of it
+close the viewport
+\begin{verbatim}
+makeViewport3D(knot, concat ["knot",p::String,q::String])$VIEW3D
+\end{verbatim}
 <<*>>=
 --S 8 of 8
-makeViewport3D(knot, concat ["knot",p::String,q::String])$VIEW3D
---R 
---R   There are 2 exposed and 0 unexposed library operations named 
---R      makeViewport3D having 2 argument(s) but none was determined to be
---R      applicable. Use HyperDoc Browse, or issue
---R                         )display op makeViewport3D
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      makeViewport3D with argument type(s) 
---R                                   Symbol
---R                                   String
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+close(v)
 --E 8
 )spool 
 )lisp (bye)
diff --git a/src/input/repa6.input.pamphlet b/src/input/repa6.input.pamphlet
index 352a022..099c75d 100644
--- a/src/input/repa6.input.pamphlet
+++ b/src/input/repa6.input.pamphlet
@@ -39,7 +39,7 @@ representations of the alternating group A6.
 We generate A6 by the permutations threecycle x=(1,2,3)
 and the 5-cycle y=(2,3,4,5,6)
 <<*>>=
---S 1  of 33
+--S 1 of 33
 genA6 : List PERM INT := [cycle [1,2,3], cycle [2,3,4,5,6]]
 --R 
 --R
@@ -50,7 +50,7 @@ genA6 : List PERM INT := [cycle [1,2,3], cycle [2,3,4,5,6]]
 @ 
 pRA6 is the permutation representation over the Integers...
 <<*>>=
---S 2  of 33
+--S 2 of 33
 pRA6 := permutationRepresentation (genA6, 6)
 --R 
 --R
@@ -71,7 +71,7 @@ pRA6 := permutationRepresentation (genA6, 6)
 @
 And pRA6m2 is the permutation representation over PrimeField 2:
 <<*>>=
---S 3  of 33
+--S 3 of 33
 pRA6m2 : List Matrix PrimeField 2 := pRA6
 --R 
 --R
@@ -117,7 +117,7 @@ sp0 := meatAxe pRA6m2
 We have found the trivial module as a factormodule
 and a 5-dimensional submodule.
 <<*>>=
---S 5  of 33
+--S 5 of 33
 dA6d1 := sp0.2
 --R 
 --R
@@ -128,7 +128,7 @@ dA6d1 := sp0.2
 @ 
 Try to split again...
 <<*>>=
---S 6  of 33
+--S 6 of 33
 sp1 := meatAxe sp0.1
 --R 
 --R   Fingerprint element in generated algebra is singular
@@ -158,7 +158,7 @@ sp1 := meatAxe sp0.1
 And find a 4-dimensional submodule, say dA6d4a, and the
 trivial one again.
 <<*>>=
---S 7  of 33
+--S 7 of 33
 dA6d4a := sp1.2
 --R 
 --R
@@ -175,13 +175,13 @@ dA6d4a := sp1.2
 @
 Now we want to test, whether dA6d4a is absolutely irreducible...
 <<*>>=
---S 8  of 33 random input, ok to fail
+--S 8 of 33 random input, FAILURE OK
 isAbsolutelyIrreducible? dA6d4a
 --R 
 --R   Random element in generated algebra does
 --R     not have a one-dimensional kernel
---R   Random element in generated algebra has
---R     one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
 --R   Random element in generated algebra has
 --R     one-dimensional kernel
 --R     We know that all the cyclic submodules generated by all
@@ -204,7 +204,7 @@ What is the degree of the representation belonging to partition
 [2,2,1,1]?
 <<*>>=
 -- lambda : PRTITION := partition [2,2,1,1]
---S 9  of 33
+--S 9 of 33
 lambda := [2,2,1,1]
 --R 
 --R
@@ -213,21 +213,11 @@ lambda := [2,2,1,1]
 --E 9
 
 --S 10 of 33
-dimIrrRepSym lambda
---R 
---R   There are no library operations named dimIrrRepSym 
---R      Use HyperDoc Browse or issue
---R                            )what op dimIrrRepSym
---R      to learn if there is any operation containing " dimIrrRepSym " in
---R      its name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      dimIrrRepSym with argument type(s) 
---R                            List PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+dimensionOfIrreducibleRepresentation lambda
+--R 
+--R
+--R   (10)  9
+--R                                                        Type: PositiveInteger
 --E 10
 
 @
@@ -235,22 +225,28 @@ Now create the restriction to A6:
 <<*>>=
 
 --S 11 of 33
-d2211  := irrRepSymNat(lambda, genA6)
---R 
---R   There are no library operations named irrRepSymNat 
---R      Use HyperDoc Browse or issue
---R                            )what op irrRepSymNat
---R      to learn if there is any operation containing " irrRepSymNat " in
---R      its name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      irrRepSymNat with argument type(s) 
---R                            List PositiveInteger
---R                          List Permutation Integer
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+d2211  := irreducibleRepresentation(lambda, genA6)
+--R 
+--R
+--R   (11)
+--R    +1  0  0  - 1   1    0    0    0    0 + + 0    0   1   0   0  0   1   0  0+
+--R    |                                     | |                                 |
+--R    |0  1  0   1    0    1    0    0    0 | | 0    0   0   0   1  0  - 1  0  0|
+--R    |                                     | |                                 |
+--R    |0  0  1   0    1   - 1   0    0    0 | | 0    0   0   0   0  1   1   0  0|
+--R    |                                     | |                                 |
+--R    |0  0  0  - 1   0    0   - 1   0    0 | | 0    0   0   0   0  0   1   1  0|
+--R    |                                     | |                                 |
+--R   [|0  0  0   0   - 1   0    0   - 1   0 |,| 0    0   0   0   0  0  - 1  0  1|]
+--R    |                                     | |                                 |
+--R    |0  0  0   0    0   - 1   0    0   - 1| | 0    0   0   0   0  0   1   0  0|
+--R    |                                     | |                                 |
+--R    |0  0  0   1    0    0    0    0    0 | |- 1   0   0   0   0  0  - 1  0  0|
+--R    |                                     | |                                 |
+--R    |0  0  0   0    1    0    0    0    0 | | 0   - 1  0   0   0  0   1   0  0|
+--R    |                                     | |                                 |
+--R    +0  0  0   0    0    1    0    0    0 + + 0    0   0  - 1  0  0  - 1  0  0+
+--R                                                    Type: List Matrix Integer
 --E 11
 
 @
@@ -259,13 +255,25 @@ And d2211m2 is the representation over PrimeField 2:
 --S 12 of 33
 d2211m2 : List Matrix PrimeField 2 := d2211
 --R 
---R 
---RDaly Bug
---R   Cannot convert right-hand side of assignment
---R   d2211
 --R
---R      to an object of the type List Matrix PrimeField 2 of the 
---R      left-hand side.
+--R          +1  0  0  1  1  0  0  0  0+ +0  0  1  0  0  0  1  0  0+
+--R          |                         | |                         |
+--R          |0  1  0  1  0  1  0  0  0| |0  0  0  0  1  0  1  0  0|
+--R          |                         | |                         |
+--R          |0  0  1  0  1  1  0  0  0| |0  0  0  0  0  1  1  0  0|
+--R          |                         | |                         |
+--R          |0  0  0  1  0  0  1  0  0| |0  0  0  0  0  0  1  1  0|
+--R          |                         | |                         |
+--R   (12)  [|0  0  0  0  1  0  0  1  0|,|0  0  0  0  0  0  1  0  1|]
+--R          |                         | |                         |
+--R          |0  0  0  0  0  1  0  0  1| |0  0  0  0  0  0  1  0  0|
+--R          |                         | |                         |
+--R          |0  0  0  1  0  0  0  0  0| |1  0  0  0  0  0  1  0  0|
+--R          |                         | |                         |
+--R          |0  0  0  0  1  0  0  0  0| |0  1  0  0  0  0  1  0  0|
+--R          |                         | |                         |
+--R          +0  0  0  0  0  1  0  0  0+ +0  0  0  1  0  0  1  0  0+
+--R                                               Type: List Matrix PrimeField 2
 --E 12
 
 @ 
@@ -274,10 +282,22 @@ And split it:
 --S 13 of 33
 sp2 := meatAxe d2211m2
 --R 
---R 
---RDaly Bug
---R   d2211m2 is declared as being in List Matrix PrimeField 2 but has not
---R      been given a value.
+--R   Fingerprint element in generated algebra is singular
+--R     A proper cyclic submodule is found.
+--R     Transition matrix computed
+--R     The inverse of the transition matrix computed
+--R     Now transform the matrices
+--R
+--R                                       +1  0  0  0  0+ +1  1  1  0  0+
+--R           +1  0  1  1+ +0  0  1  0+   |             | |             |
+--R           |          | |          |   |0  1  1  1  1| |0  0  1  1  1|
+--R           |0  1  0  1| |1  1  1  1|   |             | |             |
+--R   (13)  [[|          |,|          |],[|0  1  1  0  0|,|1  0  0  1  0|]]
+--R           |1  1  0  0| |1  0  1  1|   |             | |             |
+--R           |          | |          |   |0  1  0  1  0| |0  0  1  0  1|
+--R           +0  1  0  0+ +0  1  0  1+   |             | |             |
+--R                                       +0  1  1  1  0+ +1  0  0  1  1+
+--R                                          Type: List List Matrix PrimeField 2
 --E 13
 
 @
@@ -285,69 +305,52 @@ A 5 and a 4-dimensional one.
  
 we take the 4-dimensional one, say dA6d4b:
 <<*>>=
---S 14  of 33
+--S 14 of 33
 dA6d4b := sp2.1
 --R 
---R   There are no library operations named sp2 
---R      Use HyperDoc Browse or issue
---R                                )what op sp2
---R      to learn if there is any operation containing " sp2 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named sp2 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R
+--R          +1  0  1  1+ +0  0  1  0+
+--R          |          | |          |
+--R          |0  1  0  1| |1  1  1  1|
+--R   (14)  [|          |,|          |]
+--R          |1  1  0  0| |1  0  1  1|
+--R          |          | |          |
+--R          +0  1  0  0+ +0  1  0  1+
+--R                                               Type: List Matrix PrimeField 2
 --E 14
 
 @
 This is absolutely irreducible, too ...
 <<*>>=
---S 15  of 33
+--S 15 of 33 random generation, FAILURE OK.
 isAbsolutelyIrreducible? dA6d4b
 --R 
---R   There are 1 exposed and 0 unexposed library operations named 
---R      isAbsolutelyIrreducible? having 1 argument(s) but none was 
---R      determined to be applicable. Use HyperDoc Browse, or issue
---R                    )display op isAbsolutelyIrreducible?
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      isAbsolutelyIrreducible? with argument type(s) 
---R                               Variable dA6d4b
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra has
+--R     one-dimensional kernel
+--R     We know that all the cyclic submodules generated by all
+--R       non-trivial element of the singular matrix under view are
+--R       not proper, hence Norton's irreducibility test can be done:
+--R     The generated cyclic submodule was not proper
+--R     Representation is absolutely irreducible
+--R
+--R   (15)  true
+--R                                                                Type: Boolean
 --E 15
 
 @ 
 And dA6d4a and dA6d4b are not equivalent:
 <<*>>=
---S 16 of 33
+--S 16 of 33 random generation, FAILURE OK.
 areEquivalent? ( dA6d4a , dA6d4b )
 --R 
---R   There are 1 exposed and 0 unexposed library operations named 
---R      areEquivalent? having 2 argument(s) but none was determined to be
---R      applicable. Use HyperDoc Browse, or issue
---R                         )display op areEquivalent?
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      areEquivalent? with argument type(s) 
---R                          List Matrix PrimeField 2
---R                               Variable dA6d4b
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Dimensions of kernels differ
+--R
+--R   Representations are not equivalent.
+--R
+--R   (16)  [0]
+--R                                                    Type: Matrix PrimeField 2
 --E 16
 
 @ 
@@ -355,25 +358,74 @@ So the third irreducible representation is found.
  
 Now construct a new representation with the help of the tensorproduct
 <<*>>=
---S 17  of 33
+--S 17 of 33
 dA6d16 := tensorProduct ( dA6d4a , dA6d4b )
 --R 
---R   There are 2 exposed and 0 unexposed library operations named 
---R      tensorProduct having 2 argument(s) but none was determined to be 
---R      applicable. Use HyperDoc Browse, or issue
---R                          )display op tensorProduct
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      tensorProduct with argument type(s) 
---R                          List Matrix PrimeField 2
---R                               Variable dA6d4b
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R
+--R   (17)
+--R    +0  0  0  0  1  0  1  1  0  0  0  0  0  0  0  0+
+--R    |                                              |
+--R    |0  0  0  0  0  1  0  1  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  1  1  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  1  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  1  0  1  1  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  0  1  0  1  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  1  1  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  0  1  0  0  0  0  0  0|
+--R   [|                                              |,
+--R    |1  0  1  1  0  0  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  1  0  1  0  0  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |1  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  0  0  0  0  1  0  1  1|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  0  0  0  0  0  1  0  1|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  0  0  0  0  1  1  0  0|
+--R    |                                              |
+--R    +0  0  0  0  0  0  0  0  0  0  0  0  0  1  0  0+
+--R    +0  0  0  0  0  0  1  0  0  0  1  0  0  0  1  0+
+--R    |                                              |
+--R    |0  0  0  0  1  1  1  1  1  1  1  1  1  1  1  1|
+--R    |                                              |
+--R    |0  0  0  0  1  0  1  1  1  0  1  1  1  0  1  1|
+--R    |                                              |
+--R    |0  0  0  0  0  1  0  1  0  1  0  1  0  1  0  1|
+--R    |                                              |
+--R    |0  0  1  0  0  0  1  0  0  0  0  0  0  0  1  0|
+--R    |                                              |
+--R    |1  1  1  1  1  1  1  1  0  0  0  0  1  1  1  1|
+--R    |                                              |
+--R    |1  0  1  1  1  0  1  1  0  0  0  0  1  0  1  1|
+--R    |                                              |
+--R    |0  1  0  1  0  1  0  1  0  0  0  0  0  1  0  1|
+--R    |                                              |]
+--R    |0  0  1  0  0  0  1  0  0  0  1  0  0  0  0  0|
+--R    |                                              |
+--R    |1  1  1  1  1  1  1  1  1  1  1  1  0  0  0  0|
+--R    |                                              |
+--R    |1  0  1  1  1  0  1  1  1  0  1  1  0  0  0  0|
+--R    |                                              |
+--R    |0  1  0  1  0  1  0  1  0  1  0  1  0  0  0  0|
+--R    |                                              |
+--R    |0  0  1  0  0  0  1  0  0  0  1  0  0  0  1  0|
+--R    |                                              |
+--R    |1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1|
+--R    |                                              |
+--R    |1  0  1  1  1  0  1  1  1  0  1  1  1  0  1  1|
+--R    |                                              |
+--R    +0  1  0  1  0  1  0  1  0  1  0  1  0  1  0  1+
+--R                                               Type: List Matrix PrimeField 2
 --E 17
 
 @ 
@@ -382,149 +434,508 @@ And try to split it...
 --S 18 of 33
 sp3 := meatAxe dA6d16
 --R 
---R   There are 1 exposed and 0 unexposed library operations named meatAxe
---R      having 1 argument(s) but none was determined to be applicable. 
---R      Use HyperDoc Browse, or issue
---R                             )display op meatAxe
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      meatAxe with argument type(s) 
---R                               Variable dA6d16
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Fingerprint element in generated algebra is non-singular
+--R   Fingerprint element in generated algebra is singular
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R   Fingerprint element in generated algebra is non-singular
+--R   Fingerprint element in generated algebra is singular
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R   Fingerprint element in generated algebra is singular
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     We know that all the cyclic submodules generated by all
+--R       non-trivial element of the singular matrix under view are
+--R       not proper, hence Norton's irreducibility test can be done:
+--R     The generated cyclic submodule was not proper
+--R     Representation is irreducible, but we don't know
+--R       whether it is absolutely irreducible
+--R
+--R   (18)
+--R   [
+--R      +0  0  0  0  0  0  0  0  1  0  1  0  0  0  0  0+
+--R      |                                              |
+--R      |0  0  0  0  0  0  0  0  0  1  1  1  0  0  0  0|
+--R      |                                              |
+--R      |0  0  0  0  0  0  0  0  1  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      |0  0  0  0  0  0  0  0  1  1  0  0  0  0  0  0|
+--R      |                                              |
+--R      |1  0  1  0  0  0  0  0  0  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      |0  1  1  1  0  0  0  0  0  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      |1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      |1  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0|
+--R     [|                                              |,
+--R      |0  0  0  0  1  0  1  0  0  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      |0  0  0  0  0  1  1  1  0  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      |0  0  0  0  1  0  0  0  0  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      |0  0  0  0  1  1  0  0  0  0  0  0  0  0  0  0|
+--R      |                                              |
+--R      |0  0  0  0  0  0  0  0  0  0  0  0  1  0  1  0|
+--R      |                                              |
+--R      |0  0  0  0  0  0  0  0  0  0  0  0  0  1  1  1|
+--R      |                                              |
+--R      |0  0  0  0  0  0  0  0  0  0  0  0  1  0  0  0|
+--R      |                                              |
+--R      +0  0  0  0  0  0  0  0  0  0  0  0  1  1  0  0+
+--R      +0  0  0  0  0  1  1  0  0  1  1  0  0  1  1  0+
+--R      |                                              |
+--R      |0  0  0  0  0  1  0  1  0  1  0  1  0  1  0  1|
+--R      |                                              |
+--R      |0  0  0  0  1  1  1  0  1  1  1  0  1  1  1  0|
+--R      |                                              |
+--R      |0  0  0  0  0  1  1  1  0  1  1  1  0  1  1  1|
+--R      |                                              |
+--R      |0  1  1  0  0  1  1  0  0  1  1  0  0  1  1  0|
+--R      |                                              |
+--R      |0  1  0  1  0  1  0  1  0  1  0  1  0  1  0  1|
+--R      |                                              |
+--R      |1  1  1  0  1  1  1  0  1  1  1  0  1  1  1  0|
+--R      |                                              |
+--R      |0  1  1  1  0  1  1  1  0  1  1  1  0  1  1  1|
+--R      |                                              |]
+--R      |0  1  1  0  0  0  0  0  0  1  1  0  0  1  1  0|
+--R      |                                              |
+--R      |0  1  0  1  0  0  0  0  0  1  0  1  0  1  0  1|
+--R      |                                              |
+--R      |1  1  1  0  0  0  0  0  1  1  1  0  1  1  1  0|
+--R      |                                              |
+--R      |0  1  1  1  0  0  0  0  0  1  1  1  0  1  1  1|
+--R      |                                              |
+--R      |0  1  1  0  0  1  1  0  0  0  0  0  0  1  1  0|
+--R      |                                              |
+--R      |0  1  0  1  0  1  0  1  0  0  0  0  0  1  0  1|
+--R      |                                              |
+--R      |1  1  1  0  1  1  1  0  0  0  0  0  1  1  1  0|
+--R      |                                              |
+--R      +0  1  1  1  0  1  1  1  0  0  0  0  0  1  1  1+
+--R     ]
+--R                                          Type: List List Matrix PrimeField 2
 --E 18
 
 @ 
 The representation is irreducible, but may be not
 absolutely irreducible.
 <<*>>=
---S 19  of 33
+--S 19 of 33
 isAbsolutelyIrreducible? dA6d16
 --R 
---R   There are 1 exposed and 0 unexposed library operations named 
---R      isAbsolutelyIrreducible? having 1 argument(s) but none was 
---R      determined to be applicable. Use HyperDoc Browse, or issue
---R                    )display op isAbsolutelyIrreducible?
---R      to learn more about the available operations. Perhaps 
---R      package-calling the operation or using coercions on the arguments
---R      will allow you to apply the operation.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named 
---R      isAbsolutelyIrreducible? with argument type(s) 
---R                               Variable dA6d16
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   We have not found a one-dimensional kernel so far,
+--R     as we do a random search you could try again
+--R
+--R   (19)  false
+--R                                                                Type: Boolean
 --E 19
 
 @ 
 So let's try the same over the field with 4 elements:
 <<*>>=
---S 20  of 33
+--S 20 of 33
 gf4 := FiniteField(2,2)
 --R 
 --R
---R   (10)  FiniteField(2,2)
+--R   (20)  FiniteField(2,2)
 --R                                                                 Type: Domain
 --E 20
 
---S 21  of 33
+--S 21 of 33
 dA6d16gf4 : List Matrix gf4 := dA6d16
 --R 
---R 
---RDaly Bug
---R   Cannot convert right-hand side of assignment
---R   dA6d16
 --R
---R      to an object of the type List Matrix FiniteField(2,2) of the 
---R      left-hand side.
+--R   (21)
+--R    +0  0  0  0  1  0  1  1  0  0  0  0  0  0  0  0+
+--R    |                                              |
+--R    |0  0  0  0  0  1  0  1  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  1  1  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  1  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  1  0  1  1  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  0  1  0  1  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  1  1  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  0  1  0  0  0  0  0  0|
+--R   [|                                              |,
+--R    |1  0  1  1  0  0  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  1  0  1  0  0  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |1  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  0  0  0  0  1  0  1  1|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  0  0  0  0  0  1  0  1|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  0  0  0  0  1  1  0  0|
+--R    |                                              |
+--R    +0  0  0  0  0  0  0  0  0  0  0  0  0  1  0  0+
+--R    +0  0  0  0  0  0  1  0  0  0  1  0  0  0  1  0+
+--R    |                                              |
+--R    |0  0  0  0  1  1  1  1  1  1  1  1  1  1  1  1|
+--R    |                                              |
+--R    |0  0  0  0  1  0  1  1  1  0  1  1  1  0  1  1|
+--R    |                                              |
+--R    |0  0  0  0  0  1  0  1  0  1  0  1  0  1  0  1|
+--R    |                                              |
+--R    |0  0  1  0  0  0  1  0  0  0  0  0  0  0  1  0|
+--R    |                                              |
+--R    |1  1  1  1  1  1  1  1  0  0  0  0  1  1  1  1|
+--R    |                                              |
+--R    |1  0  1  1  1  0  1  1  0  0  0  0  1  0  1  1|
+--R    |                                              |
+--R    |0  1  0  1  0  1  0  1  0  0  0  0  0  1  0  1|
+--R    |                                              |]
+--R    |0  0  1  0  0  0  1  0  0  0  1  0  0  0  0  0|
+--R    |                                              |
+--R    |1  1  1  1  1  1  1  1  1  1  1  1  0  0  0  0|
+--R    |                                              |
+--R    |1  0  1  1  1  0  1  1  1  0  1  1  0  0  0  0|
+--R    |                                              |
+--R    |0  1  0  1  0  1  0  1  0  1  0  1  0  0  0  0|
+--R    |                                              |
+--R    |0  0  1  0  0  0  1  0  0  0  1  0  0  0  1  0|
+--R    |                                              |
+--R    |1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1|
+--R    |                                              |
+--R    |1  0  1  1  1  0  1  1  1  0  1  1  1  0  1  1|
+--R    |                                              |
+--R    +0  1  0  1  0  1  0  1  0  1  0  1  0  1  0  1+
+--R                                           Type: List Matrix FiniteField(2,2)
 --E 21
 
 --S 22 of 33
 sp4 := meatAxe dA6d16gf4
 --R 
---R 
---RDaly Bug
---R   dA6d16gf4 is declared as being in List Matrix FiniteField(2,2) but 
---R      has not been given a value.
+--R   Fingerprint element in generated algebra is non-singular
+--R   Fingerprint element in generated algebra is singular
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R   Fingerprint element in generated algebra is non-singular
+--R   Fingerprint element in generated algebra is singular
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R   Fingerprint element in generated algebra is singular
+--R     The generated cyclic submodule was not proper
+--R     The generated cyclic submodule was not proper
+--R     A proper cyclic submodule is found.
+--R     Transition matrix computed
+--R     The inverse of the transition matrix computed
+--R     Now transform the matrices
+--R
+--R   (22)
+--R   [
+--R      +  %A    %A + 1    0       %A      1     %A + 1    0     0 +
+--R      |                                                          |
+--R      |  0       0       %A    %A + 1    %A      %A      0     0 |
+--R      |                                                          |
+--R      |  %A    %A + 1    %A      1     %A + 1    0       0     0 |
+--R      |                                                          |
+--R      |  %A    %A + 1    %A      1       %A      0       0     0 |
+--R     [|                                                          |,
+--R      |%A + 1    1       1       1       0       0     %A + 1  %A|
+--R      |                                                          |
+--R      |  0       0     %A + 1    1       0       0       %A    0 |
+--R      |                                                          |
+--R      |  1       0       1       1       0       0       0     0 |
+--R      |                                                          |
+--R      +  1       1       0       0       0       0       0     0 +
+--R      +  1       0       %A      0       1       1       %A    %A + 1+
+--R      |                                                              |
+--R      |  1     %A + 1    0       0       0     %A + 1    1     %A + 1|
+--R      |                                                              |
+--R      |  %A      1     %A + 1  %A + 1  %A + 1    1       %A      0   |
+--R      |                                                              |
+--R      |%A + 1  %A + 1    0       0       1     %A + 1    1       1   |
+--R      |                                                              |]
+--R      |  1       0     %A + 1    0       1       1       %A      %A  |
+--R      |                                                              |
+--R      |  0       0     %A + 1  %A + 1  %A + 1    1       1       %A  |
+--R      |                                                              |
+--R      |  0       0       1       0       0       1       0       1   |
+--R      |                                                              |
+--R      +  0       %A      0       %A      1     %A + 1  %A + 1    %A  +
+--R     ,
+--R
+--R      +0     1       1     %A + 1  0  0  0  0+
+--R      |                                      |
+--R      |1     1     %A + 1    0     0  0  0  0|
+--R      |                                      |
+--R      |%A    0       0       0     0  0  0  0|
+--R      |                                      |
+--R      |1     %A      0       0     0  0  0  0|
+--R     [|                                      |,
+--R      |%A  %A + 1    1       1     1  0  1  1|
+--R      |                                      |
+--R      |0     0       %A      1     0  1  0  1|
+--R      |                                      |
+--R      |%A    1       0       1     1  1  0  0|
+--R      |                                      |
+--R      +1     %A    %A + 1    %A    0  1  0  0+
+--R      +%A + 1    1       %A      0       0     %A + 1    0       1   +
+--R      |                                                              |
+--R      |  0       %A      1       1       1       0     %A + 1    %A  |
+--R      |                                                              |
+--R      |  0     %A + 1    0     %A + 1  %A + 1    1     %A + 1    %A  |
+--R      |                                                              |
+--R      |  1     %A + 1    1     %A + 1    0       0     %A + 1    1   |
+--R      |                                                              |]
+--R      |  0       %A      0     %A + 1  %A + 1    0       0     %A + 1|
+--R      |                                                              |
+--R      |%A + 1    0     %A + 1    %A      0     %A + 1    0     %A + 1|
+--R      |                                                              |
+--R      |  0       1       0       1     %A + 1    0     %A + 1  %A + 1|
+--R      |                                                              |
+--R      +  %A      %A      %A      1       %A      %A      1     %A + 1+
+--R     ]
+--R                                      Type: List List Matrix FiniteField(2,2)
 --E 22
 
 @
 Now we find two 8-dimensional ones, dA6d8a and dA6d8b.
 <<*>>=
---S 23  of 33
+--S 23 of 33
 dA6d8a : List Matrix gf4  := sp4.1
 --R 
---R   There are no library operations named sp4 
---R      Use HyperDoc Browse or issue
---R                                )what op sp4
---R      to learn if there is any operation containing " sp4 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named sp4 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R
+--R   (23)
+--R    +  %A    %A + 1    0       %A      1     %A + 1    0     0 +
+--R    |                                                          |
+--R    |  0       0       %A    %A + 1    %A      %A      0     0 |
+--R    |                                                          |
+--R    |  %A    %A + 1    %A      1     %A + 1    0       0     0 |
+--R    |                                                          |
+--R    |  %A    %A + 1    %A      1       %A      0       0     0 |
+--R   [|                                                          |,
+--R    |%A + 1    1       1       1       0       0     %A + 1  %A|
+--R    |                                                          |
+--R    |  0       0     %A + 1    1       0       0       %A    0 |
+--R    |                                                          |
+--R    |  1       0       1       1       0       0       0     0 |
+--R    |                                                          |
+--R    +  1       1       0       0       0       0       0     0 +
+--R    +  1       0       %A      0       1       1       %A    %A + 1+
+--R    |                                                              |
+--R    |  1     %A + 1    0       0       0     %A + 1    1     %A + 1|
+--R    |                                                              |
+--R    |  %A      1     %A + 1  %A + 1  %A + 1    1       %A      0   |
+--R    |                                                              |
+--R    |%A + 1  %A + 1    0       0       1     %A + 1    1       1   |
+--R    |                                                              |]
+--R    |  1       0     %A + 1    0       1       1       %A      %A  |
+--R    |                                                              |
+--R    |  0       0     %A + 1  %A + 1  %A + 1    1       1       %A  |
+--R    |                                                              |
+--R    |  0       0       1       0       0       1       0       1   |
+--R    |                                                              |
+--R    +  0       %A      0       %A      1     %A + 1  %A + 1    %A  +
+--R                                           Type: List Matrix FiniteField(2,2)
 --E 23
 
 --S 24 of 33
 dA6d8b : List Matrix gf4  := sp4.2
 --R 
---R   There are no library operations named sp4 
---R      Use HyperDoc Browse or issue
---R                                )what op sp4
---R      to learn if there is any operation containing " sp4 " in its 
---R      name.
---R 
---RDaly Bug
---R   Cannot find a definition or applicable library operation named sp4 
---R      with argument type(s) 
---R                               PositiveInteger
---R      
---R      Perhaps you should use "@" to indicate the required return type, 
---R      or "$" to specify which version of the function you need.
+--R
+--R   (24)
+--R    +0     1       1     %A + 1  0  0  0  0+
+--R    |                                      |
+--R    |1     1     %A + 1    0     0  0  0  0|
+--R    |                                      |
+--R    |%A    0       0       0     0  0  0  0|
+--R    |                                      |
+--R    |1     %A      0       0     0  0  0  0|
+--R   [|                                      |,
+--R    |%A  %A + 1    1       1     1  0  1  1|
+--R    |                                      |
+--R    |0     0       %A      1     0  1  0  1|
+--R    |                                      |
+--R    |%A    1       0       1     1  1  0  0|
+--R    |                                      |
+--R    +1     %A    %A + 1    %A    0  1  0  0+
+--R    +%A + 1    1       %A      0       0     %A + 1    0       1   +
+--R    |                                                              |
+--R    |  0       %A      1       1       1       0     %A + 1    %A  |
+--R    |                                                              |
+--R    |  0     %A + 1    0     %A + 1  %A + 1    1     %A + 1    %A  |
+--R    |                                                              |
+--R    |  1     %A + 1    1     %A + 1    0       0     %A + 1    1   |
+--R    |                                                              |]
+--R    |  0       %A      0     %A + 1  %A + 1    0       0     %A + 1|
+--R    |                                                              |
+--R    |%A + 1    0     %A + 1    %A      0     %A + 1    0     %A + 1|
+--R    |                                                              |
+--R    |  0       1       0       1     %A + 1    0     %A + 1  %A + 1|
+--R    |                                                              |
+--R    +  %A      %A      %A      1       %A      %A      1     %A + 1+
+--R                                           Type: List Matrix FiniteField(2,2)
 --E 24
 
 @
 Both are absolutely irreducible...
 <<*>>=
---S 25  of 33
+--S 25 of 33 random generation, FAILURE OK.
 isAbsolutelyIrreducible? dA6d8a
 --R 
---R 
---RDaly Bug
---R   dA6d8a is declared as being in List Matrix FiniteField(2,2) but has 
---R      not been given a value.
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra has
+--R     one-dimensional kernel
+--R     We know that all the cyclic submodules generated by all
+--R       non-trivial element of the singular matrix under view are
+--R       not proper, hence Norton's irreducibility test can be done:
+--R     The generated cyclic submodule was not proper
+--R     Representation is absolutely irreducible
+--R
+--R   (25)  true
+--R                                                                Type: Boolean
 --E 25
 
---S 26 of 33
+--S 26 of 33 random generation, FAILURE OK.
 isAbsolutelyIrreducible? dA6d8b
 --R 
---R 
---RDaly Bug
---R   dA6d8b is declared as being in List Matrix FiniteField(2,2) but has 
---R      not been given a value.
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra has
+--R     one-dimensional kernel
+--R     We know that all the cyclic submodules generated by all
+--R       non-trivial element of the singular matrix under view are
+--R       not proper, hence Norton's irreducibility test can be done:
+--R     The generated cyclic submodule was not proper
+--R     Representation is absolutely irreducible
+--R
+--R   (26)  true
+--R                                                                Type: Boolean
 --E 26
 
 @
 And they are not equivalent...
 <<*>>=
---S 27  of 33
+--S 27 of 33 random generation, FAILURE OK.
 areEquivalent? ( dA6d8a, dA6d8b )
 --R 
---R 
---RDaly Bug
---R   dA6d8a is declared as being in List Matrix FiniteField(2,2) but has 
---R      not been given a value.
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra does
+--R     not have a one-dimensional kernel
+--R   Random element in generated algebra has
+--R     one-dimensional kernel
+--R     There is no isomorphism, as the only possible one
+--R       fails to do the necessary base change
+--R
+--R   Representations are not equivalent.
+--R
+--R   (27)  [0]
+--R                                                Type: Matrix FiniteField(2,2)
 --E 27
 
 @ 
@@ -535,11 +946,11 @@ The theory tells us that there are no more irreducible ones.
 Here again are all absolutely irreducible 2-modular
 representations of A6
 <<*>>=
---S 28  of 33
+--S 28 of 33
 dA6d1
 --R 
 --R
---R   (11)  [[1],[1]]
+--R   (28)  [[1],[1]]
 --R                                               Type: List Matrix PrimeField 2
 --E 28
 
@@ -550,7 +961,7 @@ dA6d4a
 --R          +0  1  0  0+ +0  1  1  1+
 --R          |          | |          |
 --R          |0  0  1  0| |1  1  0  1|
---R   (12)  [|          |,|          |]
+--R   (29)  [|          |,|          |]
 --R          |1  0  0  0| |1  1  1  0|
 --R          |          | |          |
 --R          +0  0  0  1+ +1  1  1  1+
@@ -561,26 +972,90 @@ dA6d4a
 dA6d4b
 --R 
 --R
---R   (13)  dA6d4b
---R                                                        Type: Variable dA6d4b
+--R          +1  0  1  1+ +0  0  1  0+
+--R          |          | |          |
+--R          |0  1  0  1| |1  1  1  1|
+--R   (30)  [|          |,|          |]
+--R          |1  1  0  0| |1  0  1  1|
+--R          |          | |          |
+--R          +0  1  0  0+ +0  1  0  1+
+--R                                               Type: List Matrix PrimeField 2
 --E 30
 
 --S 31 of 33
 dA6d8a
 --R 
---R 
---RDaly Bug
---R   dA6d8a is declared as being in List Matrix FiniteField(2,2) but has 
---R      not been given a value.
+--R
+--R   (31)
+--R    +  %A    %A + 1    0       %A      1     %A + 1    0     0 +
+--R    |                                                          |
+--R    |  0       0       %A    %A + 1    %A      %A      0     0 |
+--R    |                                                          |
+--R    |  %A    %A + 1    %A      1     %A + 1    0       0     0 |
+--R    |                                                          |
+--R    |  %A    %A + 1    %A      1       %A      0       0     0 |
+--R   [|                                                          |,
+--R    |%A + 1    1       1       1       0       0     %A + 1  %A|
+--R    |                                                          |
+--R    |  0       0     %A + 1    1       0       0       %A    0 |
+--R    |                                                          |
+--R    |  1       0       1       1       0       0       0     0 |
+--R    |                                                          |
+--R    +  1       1       0       0       0       0       0     0 +
+--R    +  1       0       %A      0       1       1       %A    %A + 1+
+--R    |                                                              |
+--R    |  1     %A + 1    0       0       0     %A + 1    1     %A + 1|
+--R    |                                                              |
+--R    |  %A      1     %A + 1  %A + 1  %A + 1    1       %A      0   |
+--R    |                                                              |
+--R    |%A + 1  %A + 1    0       0       1     %A + 1    1       1   |
+--R    |                                                              |]
+--R    |  1       0     %A + 1    0       1       1       %A      %A  |
+--R    |                                                              |
+--R    |  0       0     %A + 1  %A + 1  %A + 1    1       1       %A  |
+--R    |                                                              |
+--R    |  0       0       1       0       0       1       0       1   |
+--R    |                                                              |
+--R    +  0       %A      0       %A      1     %A + 1  %A + 1    %A  +
+--R                                           Type: List Matrix FiniteField(2,2)
 --E 31
 
 --S 32 of 33
 dA6d8b
 --R 
---R 
---RDaly Bug
---R   dA6d8b is declared as being in List Matrix FiniteField(2,2) but has 
---R      not been given a value.
+--R
+--R   (32)
+--R    +0     1       1     %A + 1  0  0  0  0+
+--R    |                                      |
+--R    |1     1     %A + 1    0     0  0  0  0|
+--R    |                                      |
+--R    |%A    0       0       0     0  0  0  0|
+--R    |                                      |
+--R    |1     %A      0       0     0  0  0  0|
+--R   [|                                      |,
+--R    |%A  %A + 1    1       1     1  0  1  1|
+--R    |                                      |
+--R    |0     0       %A      1     0  1  0  1|
+--R    |                                      |
+--R    |%A    1       0       1     1  1  0  0|
+--R    |                                      |
+--R    +1     %A    %A + 1    %A    0  1  0  0+
+--R    +%A + 1    1       %A      0       0     %A + 1    0       1   +
+--R    |                                                              |
+--R    |  0       %A      1       1       1       0     %A + 1    %A  |
+--R    |                                                              |
+--R    |  0     %A + 1    0     %A + 1  %A + 1    1     %A + 1    %A  |
+--R    |                                                              |
+--R    |  1     %A + 1    1     %A + 1    0       0     %A + 1    1   |
+--R    |                                                              |]
+--R    |  0       %A      0     %A + 1  %A + 1    0       0     %A + 1|
+--R    |                                                              |
+--R    |%A + 1    0     %A + 1    %A      0     %A + 1    0     %A + 1|
+--R    |                                                              |
+--R    |  0       1       0       1     %A + 1    0     %A + 1  %A + 1|
+--R    |                                                              |
+--R    +  %A      %A      %A      1       %A      %A      1     %A + 1+
+--R                                           Type: List Matrix FiniteField(2,2)
 --E 32
 
 @ 
@@ -591,8 +1066,70 @@ representations of A6 over PrimeField 2
 dA6d16
 --R 
 --R
---R   (14)  dA6d16
---R                                                        Type: Variable dA6d16
+--R   (33)
+--R    +0  0  0  0  1  0  1  1  0  0  0  0  0  0  0  0+
+--R    |                                              |
+--R    |0  0  0  0  0  1  0  1  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  1  1  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  1  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  1  0  1  1  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  0  1  0  1  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  1  1  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  0  1  0  0  0  0  0  0|
+--R   [|                                              |,
+--R    |1  0  1  1  0  0  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  1  0  1  0  0  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |1  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  0  0  0  0  1  0  1  1|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  0  0  0  0  0  1  0  1|
+--R    |                                              |
+--R    |0  0  0  0  0  0  0  0  0  0  0  0  1  1  0  0|
+--R    |                                              |
+--R    +0  0  0  0  0  0  0  0  0  0  0  0  0  1  0  0+
+--R    +0  0  0  0  0  0  1  0  0  0  1  0  0  0  1  0+
+--R    |                                              |
+--R    |0  0  0  0  1  1  1  1  1  1  1  1  1  1  1  1|
+--R    |                                              |
+--R    |0  0  0  0  1  0  1  1  1  0  1  1  1  0  1  1|
+--R    |                                              |
+--R    |0  0  0  0  0  1  0  1  0  1  0  1  0  1  0  1|
+--R    |                                              |
+--R    |0  0  1  0  0  0  1  0  0  0  0  0  0  0  1  0|
+--R    |                                              |
+--R    |1  1  1  1  1  1  1  1  0  0  0  0  1  1  1  1|
+--R    |                                              |
+--R    |1  0  1  1  1  0  1  1  0  0  0  0  1  0  1  1|
+--R    |                                              |
+--R    |0  1  0  1  0  1  0  1  0  0  0  0  0  1  0  1|
+--R    |                                              |]
+--R    |0  0  1  0  0  0  1  0  0  0  1  0  0  0  0  0|
+--R    |                                              |
+--R    |1  1  1  1  1  1  1  1  1  1  1  1  0  0  0  0|
+--R    |                                              |
+--R    |1  0  1  1  1  0  1  1  1  0  1  1  0  0  0  0|
+--R    |                                              |
+--R    |0  1  0  1  0  1  0  1  0  1  0  1  0  0  0  0|
+--R    |                                              |
+--R    |0  0  1  0  0  0  1  0  0  0  1  0  0  0  1  0|
+--R    |                                              |
+--R    |1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1|
+--R    |                                              |
+--R    |1  0  1  1  1  0  1  1  1  0  1  1  1  0  1  1|
+--R    |                                              |
+--R    +0  1  0  1  0  1  0  1  0  1  0  1  0  1  0  1+
+--R                                               Type: List Matrix PrimeField 2
 --E 33
 )spool 
 )lisp (bye)
